          
#include <cpctelera.h>  

#include "music/mojon4.h"
#include "music/mojon7.h"

#include "sprites/naveE.h"
#include "sprites/naveEdown.h"
#include "sprites/naveEup.h"

#include "sprites/engineA.h"
#include "sprites/engineB.h"
#include "sprites/engineC.h"
#include "sprites/engineD.h"

 
 

#include "sprites/enem1c.h"
#include "sprites/enem2.h"
#include "sprites/enem3a.h"
#include "sprites/enem3b.h"

#include "sprites/boss1.h"
#include "sprites/boss2a.h"
#include "sprites/boss2b.h"

#include "sprites/chicago30.h"

#include "sprites/meteorb.h"
#include "sprites/blackholeA.h"
#include "sprites/wormhole1a.h"
#include "sprites/wormhole2a.h"



#include "sprites/explo2a.h"
#include "sprites/explo2b.h"
#include "sprites/explo2c.h"
#include "sprites/explo2d.h"
#include "sprites/explo2e.h"


#include "sprites/shot1a.h"
#include "sprites/shot1b.h"
#include "sprites/shot1c.h"
#include "sprites/shot1d.h"

#include "sprites/shot2a.h"
#include "sprites/shot2b.h"
#include "sprites/shot2c.h"
#include "sprites/shot2d.h"

#include "sprites/itemA.h"
#include "sprites/itemB.h"
#include "sprites/itemC.h"
#include "sprites/itemD.h"

#include "sprites/menuDante.h"
#include "sprites/menuNave.h"
#include "sprites/titleUp.h"
#include "sprites/moon.h"
#include "sprites/bright.h"

#include "sprites/marcadorLeft.h"
#include "sprites/marcadorRight.h"

#include "sprites/plasmaA.h"

#include "sprites/rocket0a.h"
#include "sprites/rocket0b.h"
#include "sprites/rocket0c.h"
#include "sprites/rocket0d.h"

#include "sprites/rocket2a.h"
#include "sprites/rocket2b.h"
#include "sprites/rocket2c.h"
#include "sprites/rocket2d.h"

#include "sprites/rocket4a.h"
#include "sprites/rocket4b.h"
#include "sprites/rocket4c.h"
#include "sprites/rocket4d.h"

#include "sprites/rocket6a.h"
#include "sprites/rocket6b.h"
#include "sprites/rocket6c.h"
#include "sprites/rocket6d.h"

#include "sprites/black16a16.h"
#include "sprites/black8a4.h"


#include "sprites/minifont.h"
   
   

#include "scenes.h" 


//CONTROL DEL JUEGO FACIL/DIFICIL Y HACKS PARA NO PERDER VIDAS
//PIERDE_VIDAS si es 0 no te quitaran ninguna vida (por lo tanto vidas infinitas)
#define PIERDE_VIDAS 1 
//KILL_ON_HIT si es 0 no explotara la nave cuando te den, por lo tanto eres invencible, sino dejar a 1
#define KILL_ON_HIT 0

//VIDA DEL PRIMER BOSS
#define LIFE_BOSS1 100

//VIDA DEL SEGUNDO BOSS OJO, ES LA VIDA DE CADA 1 DE LOS 4
#define LIFE_BOSS2 35

//VIDA DEL TERCER BOSS
#define LIFE_BOSS3 300





//-----------------------------------------------COLORES----------------------------------------
#define PIX_0_PAL_0 0b00000000
#define PIX_0_PAL_2 0b00001000
#define PIX_0_PAL_1 0b10000000
#define PIX_0_PAL_3 0b10001000

#define PIX_1_PAL_0 0b00000000
#define PIX_1_PAL_2 0b00000100
#define PIX_1_PAL_1 0b01000000
#define PIX_1_PAL_3 0b01000100

#define PIX_2_PAL_0 0b00000000
#define PIX_2_PAL_2 0b00000010
#define PIX_2_PAL_1 0b00100000
#define PIX_2_PAL_3 0b00100010
 
#define PIX_3_PAL_0 0b00000000
#define PIX_3_PAL_2 0b00000001
#define PIX_3_PAL_1 0b00010000
#define PIX_3_PAL_3 0b00010001


#define	col0_0_0 0x54
#define	col0_0_128 0x44
#define	col0_0_255 0x55
#define	col128_0_0 0x5C
#define	col128_0_128 0x58
#define	col128_0_255 0x5D
#define	col128_0_255 0x5D
#define	col255_0_0 0x4C
#define	col255_0_128 0x45
#define	col255_0_255 0x4D
#define	col0_128_0 0x56
#define	col0_128_128 0x46
#define	col0_128_255 0x57
#define	col128_128_0 0x5E
#define	col128_128_128 0x40
#define	col128_128_255 0x5F
#define	col255_128_0 0x4E
#define	col255_128_128 0x47
#define	col255_128_255 0x4F
#define	col0_255_0 0x52
#define	col0_255_128 0x42
#define	col0_255_255 0x53
#define	col128_255_0 0x5A
#define	col128_255_128 0x59
#define	col128_255_255 0x5B
#define	col255_255_0 0x4A
#define	col255_255_128 0x43
#define	col255_255_255 0x4B




//BC tenemos el puntero al objeto por el que vamos
//A lo usaremos para comprobar valores
//HL, DE lo usaremos para ir pillando los valores y haciendo los calculos  HL = listaObjetos[ind]   DE = listaObjetos[ind+1] (ESTO NO)
//ix apunta al listaObjetos[ind]
//iy apunta al listaObjetos[ind2]
//b tiene ind
//c tiene ind2
//a para calculos
//de y hl se usaran para hacer calculos y operaciones y las llamadas en caso de colision
/*void moverLogicaJuegoCheckCollisionUltra() __naked {
   __asm
   		moverLogicaJuegoCheckCollisionUltraStart:
   			push ix
   			push iy
   		
			;apuntamos los dos a listaobjetos
			ld ix, #_listaObjetos
			ld iy, #_listaObjetos
			
			;ponemos b y c a 0 para usarlos despues de indices
			ld bc, #0
   		
		
   			;le metemos type 0 al gobjToInsert para que sepa que tiene que parar ya
   			ld hl,#_gobjToInsert
			ld (hl),#0
   			
   			
   		moverLogicaJuegoCheckCollisionUltraBucle:
   			;si el type es 0 pasamos de este objeto al siguiente osea vamos al final del bucle
   			ld a,0(ix)
   			or a
   			jr Z,moverLogicaJuegoCheckCollisionUltraBucleFin
   			
   			;si no es cero tenemos que hacer bucle y comprobar las colisiones
   			

		moverLogicaJuegoCheckCollisionUltraBucle2:
			
   			;pasamos al siguiente
   			ld de,#16
   			add iy,de
			inc c
   			
   		moverLogicaJuegoCheckCollisionUltraBucle2a:
   		
   			;ahora hacemos un bucle comprobando hasta que lleguemos a un type 0 o el elemento no este colisionando
   			
   			;comprobamos si el type de hl es 0
   			ld a,0(iy)
   			or a
   			JR Z,moverLogicaJuegoCheckCollisionUltraBucleFin
   			
   			;if  listaObjetos[ind2].x<=listaObjetos[ind1].x+listaObjetos[ind1].w
   			;sumamos a A la W de BC apuntamos a W y usamos hl para agregar a A
			ld a,1(ix)  ;objeto.x
			add a,3(ix) ;objeto.w

   			;tenemos en A BC.x+BC.w ahora restamos DE.x
			ld l,1(iy)  ;objeto.x
   			cp l

   			;si es 0 o hace carry es que cumple DE.X es menor o igual que BC.X+BC.W y por lo tanto estan solapandose en caso de no solaparse pasamos al siguiente
   			JR NC,moverLogicaJuegoCheckCollisionUltraBucleFin
   			JR NZ,moverLogicaJuegoCheckCollisionUltraBucleFin
   			
   			
   			
   			;ahora hay que comprobar si se solapa por el otro lado    de apunta a BC.W y hl apunta a HL.X
   			
   			;if(listaObjetos[ind1].x<=listaObjetos[ind2].x+listaObjetos[ind2].w)
   			
   			ld a,1(iy)  ;objeto.x
			add a,3(iy) ;objeto.w

   			;tenemos en A BC.x+BC.w ahora restamos DE.x
			ld l,1(ix)  ;objeto.x
   			cp l
   			
   			;si es 0 o hace carry es que cumple BC.X es menor o igual que HL.X+HL.W y por lo tanto estan solapandose en caso de no solaparse pasamos al siguiente
   			JR NC,moverLogicaJuegoCheckCollisionUltraBucleFin
   			JR NZ,moverLogicaJuegoCheckCollisionUltraBucleFin
   			
   			
   			
   			;en este punto estamos seguros que estan solapados del eje X   de apunta a BC.X y hl apunta a HL.W
   			
   			;ahora hacemos exactamente lo mismo para el eje Y
   			;if(listaObjetos[ind2].y<=listaObjetos[ind1].y+listaObjetos[ind1].h)
   			ld a,2(ix)  ;objeto.y
			add a,4(ix) ;objeto.h

   			;tenemos en A BC.x+BC.w ahora restamos DE.x
			ld l,2(iy)  ;objeto.y
   			cp l
			
			;si es 0 o hace carry es que cumple DE.Y es menor o igual que BC.Y+BC.H y por lo tanto estan solapandose en caso de no solaparse pasamos al siguiente
   			JR NC,moverLogicaJuegoCheckCollisionUltraBucleFin
   			JR NZ,moverLogicaJuegoCheckCollisionUltraBucleFin
   			
   
			;en este punto estamos seguros que estan solapados del eje Y  de apunta a BC.H y hl apunta a HL.Y
			
   			;if(listaObjetos[ind1].y<=listaObjetos[ind2].y+listaObjetos[ind2].h)
   			
   		
   			
   			;metemos en A la suma de HL.Y + HL.H
   			ld a,2(iy)  ;objeto.y
			add a,4(iy) ;objeto.h

   			;tenemos en A BC.x+BC.w ahora restamos DE.x
			ld l,2(ix)  ;objeto.y
   			cp l
   
   			;si es 0 o hace carry es que cumple DE.Y es menor o igual que BC.Y+BC.H y por lo tanto estan solapandose en caso de no solaparse pasamos al siguiente
   			JR NC,moverLogicaJuegoCheckCollisionUltraBucleFin
   			JR NZ,moverLogicaJuegoCheckCollisionUltraBucleFin
   			

   			;si de es diferente de 0 lo llamamos a esa funcion
   			ld a,9(ix)
   			or a
   			jr Z,moverLogicaJuegoCheckCollisionUltraBucle3
   			
   			;no es cero por lo tanto tengo que hacerle el call a de con index4 y algo mas que no se
			ld l,9(ix)
			ld h,10(ix)
			
			push bc
			call ___sdcc_call_hl
   			
   			
   		moverLogicaJuegoCheckCollisionUltraBucle3:
   		
   			;si de es diferente de 0 lo llamamos a esa funcion
   			ld a,9(iy)
   			or a
   			jr Z,moverLogicaJuegoCheckCollisionUltraBucleFin
   			
   			;no es cero por lo tanto tengo que hacerle el call a de con index4 y algo mas que no se
			ld l,9(iy)
			ld h,10(iy)
			
			ld a,c
			ld c,b
			ld b,a
			push bc
			call ___sdcc_call_hl
   			
   			ld a,c
			ld c,b
			ld b,a
			
   			
   		moverLogicaJuegoCheckCollisionUltraBucle4:
   			;volvemos al bucle
   			jp moverLogicaJuegoCheckCollisionUltraBucle2
   		
   
   		moverLogicaJuegoCheckCollisionUltraBucleFin:
   			;le sumamos 1 a index4 y cuando llegue a 29 salimos que ya hemos acabao todo
			inc b
   			ld a,b
   			cp #29
   			JR Z,moverLogicaJuegoCheckCollisionUltraSalir
			
   		
   			;si no hemos acabado pasamos bc al siguiente objeto
   			ld de,#16
   			add ix,de
   			
   			
   			;y volvemos al bucle
   			JP moverLogicaJuegoCheckCollisionUltraBucle   			
   			
   		moverLogicaJuegoCheckCollisionUltraSalir:
   			pop iy
			pop ix
   			ret

   __endasm;
}*/



//funcion que pilla de vmdy el eje y y saca la direccion de memoria a usar en vmdptr
void getvmd() __naked {
   __asm
		;apunto al puntero donde voy a echar er viaje
		ld hl,#_vmdptr
		
		;apunto a donde tengo guardadas las direcciones parte baja
		ld a,(#_vmdy)
		ld e,a
		ld d,#0xB0
		
		;meto la parte baja de la direccion en vmdptr
		ld a,(de)
		ld (hl),a
		
		;apunto a la parte alta de vmdptr
		inc hl
		;apunto a donde tengo guardadas las direcciones parte alta
		inc d
		
		;meto la parte alta de la direccion en vmdptr
		ld a,(de)
		ld (hl),a
		
		;ya tengo la direccion en vmdptr asi que salimos
		ret			
   __endasm;
}


//dibuja un sprite de 16x16 a tope rapido
//u8* pointerToByte;  para saber donde tenemos que empezar a pintar
//u8* drawSprite16Puntero; donde este el sprite
//u8 drawSprite16y; eje y
void drawSprite16() __naked {
   __asm
		drawSprite16Start:
			;preparamos para bucle
			ld b,#16
		
			;metemos en hl la direccion donde vamos a colorear
			ld de,(#_pointerToByte)
			
			;metemos en de la direccion de lo que tenemos que colorear
			ld hl,(#_drawSprite16Puntero)
			
		drawSprite16Write:
			push de
			
			ld a,b
			
			ldi
			ldi
			ldi
			ldi
			
			pop de
			
			;para el bucle
			ld b,a
			
			;aqui miramos si tenemos que avanzar 2048 o solo 1
			ld a,(#_drawSprite16y)
			inc a
			ld (#_drawSprite16y),a
			and #7
			
			
			;si es cero sumamos solo 37B0  14256 
			jr Z,drawSprite16Suma80
			
			;sino sumamos 2048 a de
			ld a,#8
			add a,d
			ld d,a
			djnz drawSprite16Write
			
			ret
			
		drawSprite16Suma80:
			;restamos 37B0 a de  55 y 176
			ld a,e
			sub #176
			ld e,a
			jp NC,drawSprite16Suma80b
			dec d
			
		drawSprite16Suma80b:
			ld a,d
			sub #55
			ld d,a

			djnz drawSprite16Write
				
			ret			
   __endasm;
}


//dibuja un sprite de 8x4 a tope rapido
//u8* pointerToByte;  para saber donde tenemos que empezar a pintar
//u8* drawSprite16Puntero; donde este el sprite
//u8 drawSprite16y; eje y
void drawSprite8x4() __naked {
   __asm
		drawSprite8x4Start:
			;preparamos para bucle
			ld b,#4
		
			;metemos en hl la direccion donde vamos a colorear
			ld de,(#_pointerToByte)
			
			;metemos en de la direccion de lo que tenemos que colorear
			ld hl,(#_drawSprite16Puntero)
			
			;si el modulo de _drawSprite16y es menor que 4 podemos saltarnos comprobaciones
			ld a,(#_drawSprite16y)
			and #7
			cp #4
			jp C,drawSprite8x4WriteFast
			
		drawSprite8x4Write:
			push de
			
			ld a,b
			
			ldi
			ldi
			
			pop de
			
			;para el bucle
			ld b,a
			
			;aqui miramos si tenemos que avanzar 2048 o solo 1
			ld a,(#_drawSprite16y)
			inc a
			ld (#_drawSprite16y),a
			and #7
			
			
			;si es cero sumamos solo 37B0  14256 
			jr Z,drawSprite8x4Suma80
			
			;sino sumamos 2048 a de
			ld a,#8
			add a,d
			ld d,a
			djnz drawSprite8x4Write
			
			ret
			
		drawSprite8x4Suma80:
			;restamos 37B0 a de  55 y 176
			ld a,e
			sub #176
			ld e,a
			jp NC,drawSprite8x4Suma80b
			dec d
			
		drawSprite8x4Suma80b:
			ld a,d
			sub #55
			ld d,a

			djnz drawSprite8x4Write
				
			ret		

		drawSprite8x4WriteFast:
			push de
			ld a,b
			ldi
			ldi
			pop de
			
			;para el bucle
			ld b,a
			
			ld a,#8
			add a,d
			ld d,a
			djnz drawSprite8x4WriteFast
			ret
   __endasm;
}



//dibuja un sprite de 12x8 a tope rapido (se puede usar para sprites de 8x8 al pixel)
//u8* pointerToByte;  para saber donde tenemos que empezar a pintar
//u8* drawSprite16Puntero; donde este el sprite
//u8 drawSprite16y; eje y

void drawSprite12x8() __naked {
   __asm
		drawSprite12x8Start:
			;preparamos para bucle
			ld b,#8
		
			;metemos en hl la direccion donde vamos a colorear
			ld de,(#_pointerToByte)
			
			;metemos en de la direccion de lo que tenemos que colorear
			ld hl,(#_drawSprite16Puntero)
			
			
		drawSprite12x8Write:
			push de
			
			ld a,b
			
			ldi
			ldi
			ldi
			
			pop de
			
			;para el bucle
			ld b,a
			
			;aqui miramos si tenemos que avanzar 2048 o solo 1
			ld a,(#_drawSprite16y)
			inc a
			ld (#_drawSprite16y),a
			and #7
			
			
			;si es cero sumamos solo 37B0  14256 
			jr Z,drawSprite12x8Suma80
			
			;sino sumamos 2048 a de
			ld a,#8
			add a,d
			ld d,a
			djnz drawSprite12x8Write
			
			ret
			
		drawSprite12x8Suma80:
			;restamos 37B0 a de  55 y 176
			ld a,e
			sub #176
			ld e,a
			jp NC,drawSprite12x8Suma80b
			dec d
			
		drawSprite12x8Suma80b:
			ld a,d
			sub #55
			ld d,a

			djnz drawSprite12x8Write
				
			ret		

		
   __endasm;
}



//yendo pabajo pero array en orden tilenumber, direccion comienzo linea,  desp
//_punteroDeLaMuerte  --> puntero al array de la muerte
//_punteroTiles --> puntero a donde empiezan los tiles
//_contadorScroll --> u8 con contador de cuantas veces se va a buclear
void octoScroll() __naked {
   __asm
		octoScrollStart:
			ld hl, (#_punteroDeLaMuerte)
			
		octoScrollMainLoop:
			;clocks 7
			ld a,(hl)
			
			;clocks 4
			or a
			
			;si no es cero lo dibujamos
			;clocks 12
			jr nz,octoScrollMainLoopSub0

			;si es cero nos lo saltamos
			;clocks 6x4 24
			dec hl
			dec hl
			dec hl
			dec hl
			
			;clocks 10
			jp octoScrollCheckLoop
			
		octoScrollMainLoopSub0:
			;clocks 11 bajo el desp si no era cero
			dec (hl)
			
			;clocks 4
			dec a
			
			;clocks 6 pasamos HL al comienzo de la direccion de comienzo de linea
			dec hl
		
			;clocks 7+6+7+6=26 pillamos la direccion de comienzo de linea
			ld d,(hl)
			dec hl
			ld e,(hl)
			dec hl
			
			;aki hay que hacer de + a
			;clocks 4 desp=desp+E 
			add a,e
			
			;clocks 4 desplazo E con la cuenta que tengo en A
			ld e,a
			
			;clocks 7 si no hemos desbordado saltamos esta parte
			jr nc, octoScrollMainLoopSub1
			
			;clocks 4 si hemos desbordado bajamos 1 H 
			inc d
		
			;hasta aqui 
		
		octoScrollMainLoopSub1:
			;clocks 7+7+14+15=43 pillamos el tilenumber y lo metemos en bc
			ld c,(hl)
			
			;nos guardamos hl en la pilaka para hacer operaciones con hl
			push hl
			
			ld h,#0
			ld l,c
			
			;clocks 15+15+15=45 multiplicamos por 8 hl
			;por 2 hl = hl+hl
			add hl,hl; 
			
			;por 4 hl = hl+hl   +   hl+hl
			add hl,hl;
			
			;por 8 hl = hl*4 + hl*4
			add hl,hl;

			;clocks 10 cargamos el puntero a donde empiezan los tiles
			ld bc, (#_punteroTiles)
			
			;clocks 15 se lo sumamos a hl y ya tenemos en hl el puntero exacto al tile
			add hl,bc
		
			;lo guardamos en bc
			ld b,h
			ld c,l
		
			;recuperamos hl de la pilaka
			pop hl
		
			;clocks 6 y ya pasamos el hl al siguiente desp
			dec hl
		
		
			;en este punto tengo en de la memoria de video a pintar y en bc la info ke tengo ke pintar y en hl el siguiente desp
			
			
			;hasta aqui  
			
		octoScrollMainLoopDibuja:
			;clocks 4 cambiamos de y hl para usar hl mejor
			ex de,hl

			;clocks 10 me guardo 2048 en bc pa luego
			;ld bc,#2048
		
		
			;hago esto 8 veces para pintar los 8 bytes cada bucle tarda 47
			
			
			;clocks 19 pillo el byte con los 4 colores   1
			ld a,(bc)
			;clocks 7 sobreescribo el byte de memoria
			ld (hl),a
			;clocks 10 incremento para pasar a los siguientes 4 colores del tile
			inc bc
			;clocks  agrego a hl los 2048
			ld a,#8
			add a,h
			ld h,a
			
			
			;clocks 19 pillo el byte con los 4 colores   2
			ld a,(bc)
			;clocks 7 sobreescribo el byte de memoria
			ld (hl),a
			;clocks 10 incremento para pasar a los siguientes 4 colores del tile
			inc bc
			;clocks  agrego a hl los 2048
			ld a,#8
			add a,h
			ld h,a
			
			
			;clocks 19 pillo el byte con los 4 colores   3
			ld a,(bc)
			;clocks 7 sobreescribo el byte de memoria
			ld (hl),a
			;clocks 10 incremento para pasar a los siguientes 4 colores del tile
			inc bc
			;clocks  agrego a hl los 2048
			ld a,#8
			add a,h
			ld h,a
			
			
			;clocks 19 pillo el byte con los 4 colores   4
			ld a,(bc)
			;clocks 7 sobreescribo el byte de memoria
			ld (hl),a
			;clocks 10 incremento para pasar a los siguientes 4 colores del tile
			inc bc
			;clocks  agrego a hl los 2048
			ld a,#8
			add a,h
			ld h,a
			
		
			;clocks 19 pillo el byte con los 4 colores   5
			ld a,(bc)
			;clocks 7 sobreescribo el byte de memoria
			ld (hl),a
			;clocks 10 incremento para pasar a los siguientes 4 colores del tile
			inc bc
			;clocks  agrego a hl los 2048
			ld a,#8
			add a,h
			ld h,a
			
			
			;clocks 19 pillo el byte con los 4 colores   6
			ld a,(bc)
			;clocks 7 sobreescribo el byte de memoria
			ld (hl),a
			;clocks 10 incremento para pasar a los siguientes 4 colores del tile
			inc bc
			;clocks  agrego a hl los 2048
			ld a,#8
			add a,h
			ld h,a
			
			
			;clocks 19 pillo el byte con los 4 colores   7
			ld a,(bc)
			;clocks 7 sobreescribo el byte de memoria
			ld (hl),a
			;clocks 10 incremento para pasar a los siguientes 4 colores del tile
			inc bc
			;clocks  agrego a hl los 2048
			ld a,#8
			add a,h
			ld h,a
			
			
			;clocks 19 pillo el byte con los 4 colores   8
			ld a,(bc)
			;clocks 7 sobreescribo el byte de memoria
			ld (hl),a
			
			
			
			
			;clocks 4 recuperamos el hl inicial de la listaka
			ex de,hl
			
		
		octoScrollCheckLoop:
			;clocks 13+4+13+4+12  46
			ld a,(#_contadorScroll)
			dec a
			ld (#_contadorScroll),a
			or a
			jr NZ,octoScrollMainLoop
			
			
			;hasta aqui 640 total el camino largo
		
		ret			
   __endasm;
}








unsigned char scroleaStars() __naked {
   __asm
		ld b, #50
		;hl apunta a donde este el puntero de la muerte	de las estrellas
		ld hl, (#_punteroDeLaMuerteStars)		
		startloopStars:
			;primero pillamos el pendiente sacandolo de la direccion que tenga hl
			ld a, (hl)
			;hacemos la resta estafa para rellenar los flags del Z zero
			cp #255
			;si a != 0 saltamos a pintar el pixel
			jp nz, pintamosPixelStars
			dec hl
			dec hl
			dec hl
			dec hl
			djnz startloopStars
			ret
		pintamosPixelStars:
			;restamos 1 al pend en hl esta ahora mismo el pend
			dec (hl)
			;metemos el pend restado en c
			ld c, (hl)
			;pillamos el tipo de estrella y aqui deberiamos bifurcar a donde sea
			dec hl
			ld a, (hl)
			;nos colocamos hl para que apunte al pixel que tenemos ke pintar
			dec hl
			ld d, (hl)
			dec hl
			ld e, (hl)
			;miramos si hay algun pixel ya en esta posicion que no sea la estrella
			ld a, (de)
			cp #4
			jp nz, pintamosPixelStars4
			;y borramos la estrella
			ld a, #0
			ld (de),a
		pintamosPixelStars4:
			;metemos en a lo que vale c y comprobamos si ya es cero
			ld a, c
			cp #255
			;si ya es cero no dibujamos la estrella ya que estamos en el borde
			jp z, pintamosPixelStars2
			;sino bajamos el pixel al que estamos apuntado a -1
			dec de
			;miramos si hay algun pixel ya en esta posicion
			ld a, (de)
			cp #0
			;si ya hay algun pixel aqui no lo pisamos con nada y saltamos
			jp nz, pintamosPixelStars3
			;y pintamos la estrella en la nueva posicion
			ld a, #1
			ld (de),a
		pintamosPixelStars3:
			;volvemos a copiar la nueva direccion del pixel a la direccion de hl
			inc hl
			ld (hl),d
			dec hl
			ld (hl), e
		pintamosPixelStars2:
			;y pasamos al siguiente pend
			dec hl
			;volvemos al bucle
			djnz startloopStars
			;si b es 0 salimos
			ret			
   __endasm;
}
   

   
unsigned char scroleaStarsBis() __naked {
   __asm
		ld b, #50
		;hl apunta a donde este el puntero de la muerte	de las estrellas
		ld hl, (#_punteroDeLaMuerteStars)		
		startloopStarsBis:
			;primero pillamos el pendiente sacandolo de la direccion que tenga hl
			ld a, (hl)
			;hacemos la resta estafa para rellenar los flags del Z zero
			cp #255
			;si a != 0 saltamos a pintar el pixel
			jp nz, pintamosPixelStarsBis
			dec hl
			dec hl
			dec hl
			dec hl
			djnz startloopStarsBis
			ret
		pintamosPixelStarsBis:
			;metemos el pend restado en c
			ld c, (hl)
			;pillamos el tipo de estrella y aqui deberiamos bifurcar a donde sea
			dec hl
			ld a, (hl)
			;nos colocamos hl para que apunte al pixel que tenemos ke pintar
			dec hl
			ld d, (hl)
			dec hl
			ld e, (hl)
			;miramos si hay algun pixel ya en esta posicion que no sea la estrella
			ld a, (de)
			cp #1
			jp nz, pintamosPixelStarsBis2
			;y cambiamos el 1 por un 4
			ld a, #4
			ld (de),a
		pintamosPixelStarsBis2:
			;y pasamos al siguiente pend
			dec hl
			;volvemos al bucle
			djnz startloopStarsBis
			;si b es 0 salimos
			ret			
   __endasm;
}
   
 
//funcion que usa la minifont para pintar cadenas
//la cadena debe estar en cadenaDrawString[80] y debe finalizar con caracter 0
//punteroDeLaMuerte debe apuntar a la direccion donde vamos a empezar a pintar
//ojo solo dibujar cadenas dentro de los 8 pixeles de la fila, no cambiar de fila para mas optimizacion
// en hl vamos a tener la direccion de la pantalla donde dibujar
// en de vamos a tener la direccion del sprite de la minifont
void drawString2() __naked {
	__asm
		drawString2Start:
			;direccion de la cadena
			ld bc, #_cadenaDrawString
			
			;me guardo en la pila por donde vamos pintando
			ld de, (#_punteroDeLaMuerte)
			push de
			
		drawString2BucleCheckCaracter:
			ld a,(bc)
			or a
			jr Z,drawString2BucleFin
			
			;pintamos el byte de este caracter de bc
			sub #32
			;tenemos en a el desplazamiento de gra_minifont
			ld h,#0
			ld l,a
			ld d,#0
			ld e,a
			
			;hacemos el a por 6
			add hl,hl
			add hl,de
			add hl,hl
			
			ld de, #_gra_minifont2
			add hl,de
			
			;tengo en hl donde empiezan los bytes del caracter
			;ahora voy a situarme en la pantalla con de
			pop de
			inc de 
			;meto en la pila el siguiente byte
			push de
			dec de
			
			;y ahora le doy candela a pintar los 6 bytes
			;primer byte
			ld a,(hl)
			ld (de),a
			inc hl
			ld a,d
			add a,#8
			ld d,a
			
			;segundo byte
			ld a,(hl)
			ld (de),a
			inc hl
			ld a,d
			add a,#8
			ld d,a
			
			;tercer byte
			ld a,(hl)
			ld (de),a
			inc hl
			ld a,d
			add a,#8
			ld d,a
			
			;cuarto byte
			ld a,(hl)
			ld (de),a
			inc hl
			ld a,d
			add a,#8
			ld d,a
			
			;quinto byte
			ld a,(hl)
			ld (de),a
			inc hl
			ld a,d
			add a,#8
			ld d,a
			
			;sexto byte
			ld a,(hl)
			ld (de),a
			
			;paso al siguiente caracter y repito
			inc bc
			jp drawString2BucleCheckCaracter

		drawString2BucleFin:
			pop de
			
		drawString2Exit:
			ret
	__endasm;
}
   
 
//funcion mas potente que reorderObjectsFast, en el momento que interruptMoment es menor que 3 para de ejecutarse 
//y sigue ejecutandose hasta que haya acabado de reordenarse todo  (esto se ha descartado)
//devuelve si esta todo ordenado o no  en index4 tengo si esta todo ordenado o no
unsigned char reorderObjectsUltra() __naked {
	__asm
		;funcion reorderObjectsUltra
			push ix
			ld ix,#0
			add ix,sp
		
		;src/main.c:825: cpct_setBorder(HW_BRIGHT_WHITE);
			;ld hl, #0x0B10
			;push hl
			;call _cpct_setPALColour
			
		;src/main.c:680: index4=1;
			ld hl,#_index4
			ld (hl),#0x01

		;src/main.c:682: while(index4)
		reorderObjectsUltraWhile:
			ld hl,#_index4
			ld a,(hl)
			or a,a
			jp Z,reorderObjectsUltraWhileFin
			
			;ld hl,#_interruptMoment
			;ld a,(hl)
			;cp #3
			;jp C,reorderObjectsUltraWhileFin
			
		;src/main.c:684: index4=0;
			ld (hl),#0x00
			
		;src/main.c:685: for(index=0; index<index3; index++)
			ld hl,#_index
			ld (hl),#0x00
			
		reorderObjectsUltraFor:
		;29 MAXOBJECTS-1  index<index3
			ld hl,#_index
			ld a,(hl)
			ld b,#0x1D
			sub a,b
			jr NC,reorderObjectsUltraWhile
			
		;src/main.c:687: if(listaObjetos[index].type!=0)
		;buscamos la forma de situarnos en bc a listaObjetos[index]
			ld hl,#_index
			ld c,(hl)
			ld b,#0x00
			ld l,c
			ld h,b
			add	hl, hl
			add	hl, hl
			add	hl, hl
			add	hl, hl
			ld bc,#_listaObjetos
			add hl,bc
			ld c, l
			ld b, h
		;leemos lo que tiene listaObjetos[index].type y lo metemos en ix-1 que apuntaba a sp
			ld a, (bc)
			ld -1 (ix), a
			
		;src/main.c:689: if(listaObjetos[index+1].type!=0)
		;pillamos hl que esta apuntando a listaObjetos[index] y le sumamos 16 para llegar a listaObjetos[index+1]
			ld de,#0x10
			add hl,de
		;y lo dejamos en de
			ex de,hl
			
		;ya tenemos listaObjetos[index+1] en de y metemos en ix-2 lo ke vale type
			ld a,(de)
			ld -2 (ix),a
			
			
		;src/main.c:687: if(listaObjetos[index].type!=0)
			ld a, -1 (ix)
			or a, a
			jr Z,reorderObjectsUltraIfThen1
		;src/main.c:689: if(listaObjetos[index+1].type!=0)
			ld a, -2 (ix)
			or a,a
			jp Z,reorderObjectsUltraIfThen2
			
			
			
		;src/main.c:691: if(listaObjetos[index].x>listaObjetos[index+1].x)
			
		;pillamos listaObjetos[index].x y va para l que ahora mismo esta libre
			inc bc
			ld a, (bc)
			ld l, a
			dec bc
		;pillamos listaObjetos[index+1].x y va para a
			inc de
			ld	a, (de)
			dec de
		;hacemos el if restando a-l
			sub a, l
			jr NC, reorderObjectsUltraIfThen2
			
			
			
		;nos guardamos BC y DE porque esto se lo va a pelar dentro
			push bc
			push de
		;src/main.c:693: cpct_memcpy(&gobjToInsert, &listaObjetos[index], sizeof(gameObject));
			ld hl, #0x0010
			push hl
			push bc
			ld hl,#_gobjToInsert
			push hl
			call _cpct_memcpy
		;recuperamos BC
			pop de
			pop bc
			
			
			
			
		;nos guardamos DE porque esto se lo va a pelar, BC no lo guardo porque ya no me hace mas falta
			push de
		;src/main.c:694: cpct_memcpy(&listaObjetos[index], &listaObjetos[index+1], sizeof(gameObject));
			ld hl, #0x0010
			push hl
			push de
			push bc
			call _cpct_memcpy
		;recuperamos de
			pop de

			
			
			
		;aqui no me guardo ni DE ni BC porque ya no los voy a necesitar mas
		;src/main.c:695: cpct_memcpy(&listaObjetos[index+1], &gobjToInsert, sizeof(gameObject));
			ld hl, #0x0010
			push hl
			ld hl, #_gobjToInsert
			push hl
			push de
			call _cpct_memcpy

		;ya hemos hecho un cambio y consume mucha cpu asi que pa fuera ya
			;jp reorderObjectsUltraWhileFin
			
		;src/main.c:696: index4++;
			ld hl,#_index4
			inc (hl)
			;aqui ha hecho un cambio y debe volver al principio del bucle
			jp reorderObjectsUltraWhile
			
		reorderObjectsUltraIfThen1:
		;src/main.c:700: if(listaObjetos[index+1].type!=0)
			ld a, (de)
			or a, a
			jr Z,reorderObjectsUltraIfThen2
			
		;src/main.c:702: cpct_memcpy(&listaObjetos[index], &listaObjetos[index+1], sizeof(gameObject));
			ld hl,#0x0010
			push hl
			push de
			push bc
			call _cpct_memcpy
			
		;src/main.c:703: listaObjetos[index+1].type=0;
			ld a,#0x00
			ld (de),a

		;src/main.c:704: index4++;
			ld hl,#_index4
			inc (hl)
			;aqui ha hecho un cambio y debe volver al principio del bucle
			jp reorderObjectsUltraWhile
			
		reorderObjectsUltraIfThen2:
		;src/main.c:685: for(index=0; index<index3; index++)
			ld hl, #_index
			inc (hl)
			jp reorderObjectsUltraFor
			
		reorderObjectsUltraWhileFin:
		
		;src/main.c:825: cpct_setBorder(HW_BLACK);
			;ld hl, #0x1410
			;push hl
			;call _cpct_setPALColour
		
		;salimos
			pop ix
			ret
	__endasm;
}
 
 


//50 pegado a la izquierda
//46 centrado
//42 pegado a la derecha
//meter el numero en shakeForce
unsigned char shakeIt() __naked {
   __asm
		ld bc,#0xbc02
		out (c),c
		ld bc,#0xbd00
		
		ld hl,#_shakeForce
		ld c,(hl)
		out (c),c
		
		ret
	__endasm;
}


void interruptHandlerFast() __naked {
   __asm
			ld hl, #_interruptMoment
			dec (hl)
			ld a,(hl)

			or a
			jr NZ,interruptHandlerFastSub
			
			;si llegamos aqui es que interruptMoment es 0 y debemos mirar si hay que hacer sonar la musica o no
			
			;comprobamos si la musica esta activada, en caso de no estarlo seguimos el curso normal
			;ld de,#_musicActivated
			;ld a,(de)
			;or a
			;jr NZ, interruptHandlerFastSubMusic2
		

			;si la musica esta activada comprobamos musicMoment sea cero entonces tenemos que llamar a cpct_akp_musicPlay
			;ld de,#_musicMoment
			;ld a,(de)
			
			;si el musicMoment es cero llamamos a la musica
			;or a
			;jr NZ,interruptHandlerFastSubMusic
			
			;push ix
			;push iy
			;call _cpct_akp_musicPlay
			;pop iy
			;pop ix
			
			;le ponemos 1 para que en la proxima no llame a la musica
			;ld a,#1
			;ld (#_musicMoment),a
			
			;jp interruptHandlerFastSubMusic2
			
		;interruptHandlerFastSubMusic:
			;le ponemos 0 para que en la proxima llame a la musica
			;ld a,#0
			;ld (#_musicMoment),a
		
		interruptHandlerFastSubMusic2:
			;reseteamos el interruptMoment
			ld a,#6
			ld (#_interruptMoment),a
		
			
		
		interruptHandlerFastSub:
			;multiplicamos por 4 lo de interruptMoment
			sla a
			sla a
			
			;lo metemos en hl
			ld h,#0
			ld l,a

			;y le sumamos la dir de greatPalete
			ld de,#_greatPalete
			add hl,de
			
			ld a,(hl)
			or a
			jr Z,interruptHandlerFastFin
			
			;meto el 4
			ld de, #0x0004
			push de
			
			;y ya tengo la direccion exacta de la paleta que quiero poner asi que la cambio
			push hl
			call _cpct_setPalette
			
			;paleta cambiada y nos vamos
		interruptHandlerFastFin:
			ret
	__endasm;
}





//--------------------------------------------LISTA DE ANIMACIONES
u8* listaSpriteExplosiones[10];
u8* listaSpriteShot1[4];
u8* listaSpriteShot2[4];
u8* listaSpriteItem1[4];
u8* listaSpriteProta[7]; //nave normal, nave arriba, nave abajo, fuego grande A, fuego grande B, fuego medio C, fuego medio D
u8* listaSpriteRocket[16]; //4 lados por 4 sprites por cada lado
//u8* listaSpriteHoles[12]; //para guardar los sprites del blackhole y el wormhole
//--------------------------------------------OPTIMIZACIONES--------------------------------------------
//u8 *videoMemLineStart[200]; //para llegar mas rapido a donde empieza el video
//u8 *videoMemLineStart;  //200 para llegar mas rapido a donde empieza el video 400 bytes
u8 *vmdptr;  //esto es para usar la funcion ultra fast getvmd que te da la direccion de memoria donde comienza cada linea
u8 vmdy; 
 
 

//--------------------------------------------ESCENARIO-------------------------------------------------------
//250 x 4 bytes por cada byte que se vaya meneando por la pantalla
#define MAX_SCENE_PIX_MUL 600
#define MAX_STARS_PIX_MUL 200



//para la funcion drawSprite16 para poder pasarle los parametros
u8* drawSprite16Puntero;
u8 drawSprite16y;
//u8 drawSprite16x;  no hace falta


//para manejar el escenario en pantalla, van de 4 en 4 bytes pend, color, direccion
//u8 listaSceneMAXIMA[MAX_SCENE_PIX_MUL];   --> se pasa a B800 - BA58
u8* punteroDeLaMuerte;
u8* punteroTiles;
u8 numberTiles;
u8 contadorScroll;
u16 scene2pixIndexFix0;
u8* sceneActual; //apunta al array del escenario actual que se va a mostrar 
u8* sceneOptActual; //apunta al array del escenario opt actual que se va a mostrar 
u8 sceneNumber; //numero del nivel (simplemente por saber cual es el siguiente nivel a cargar)
u8 sceneYoffset; //por si cargamos una image que vaya mas abajo del y=0

  
//para manejar las estrellas en pantalla, van de 4 en 4 bytes pend, tipo, direccion
//tipo 0 van de byte en byte 
//tipo 1 van de 1 pixel en pixel haciendo el SLA y si el C es 1 pasan al siguiente byte con 16
//tipo 2 van de 2 pixels en 2 pixels haciendo 2 SLA y si C es 1 pasan al siguiente byte con 16
//u8 listaStarsMAXIMA[MAX_STARS_PIX_MUL];   --> lo pasamos a B700
u8* punteroDeLaMuerteStars;


//CPCT_1BITARRAY(sceneCollision, 2560); // esto son 320 bytes (32 bits/4 bytes por cada columna) (80 filas)
//u8 sceneCollision[640];  //probando 640 bytes (64 bits/8 bytes por cada columna) (80 filas)
//---> pasado a B400 - B680
u8 listaPrepareCollisions[24]; //toda la columna de tiles de la derecha (0 no hay coli, 1 si hay coli)
u16 colisionIndex;
//empieza desde la esquina superior izquierda hacia la esquina inferior izquierda cada tile de colision es de 4x8


u16 actualScenePointer; //esto es por donde vamos leyendo del escenario 
u8 acumDespScene;  //esto es el acumulamiento de desplazamiento, si es 0 leemos más datos del escenario, si es mayor de 0 no leemos nada y le restamos 1

u8 actualSceneOptPointer; //esto es por donde vamos leyendo el escenarioOpt
u8 acumDespSceneOpt;

u8 stopSceneTime; //esto es el tiempo que va a estar el escenario parado, o cero si va normalmente

u16 scene2pixIndex;  //esto guarda donde empieza y donde acaban los datos que tenemos que mostrar en pantalla de la lista de arriba
u8 stars2pixIndex;  //esto guarda por donde empieza los datos donde podemos escribir estrellas
//u8 lastAltura; //esto guarda la ultima altura donde agregamos un pixel, se va a usar por si hay que repetir algun pixel
u8 lastColor;  //esto guarda el ultimo color donde agregamos un pixel, se va a usar por si hay que repetir algun pixel


//variables para usos varios dentro de las funciones
u8* pointerToByte;
u8 index;
u8 index2;
u8 index3; 
u8 index4;


u8 addEnemyFromScript1; //se usa para agregar enemigos desde los scripts
u8 addEnemyFromScript2;


u8 moment; //va rotando con los frames de 0 a 7 es para saber si estamos en el par o impar
u8 starsMoment; //va de 0 a 1 para saber si llamar a una funcion o otra
u8 interruptMoment; //va de 0 a 5 que son las 6 interrupciones del raster
//u8 musicMoment; //esta variable toma 1 o 2 para que le interruptHandler sepa cuando tiene que llamar al music_play
//u8 musicActivated; //esta variable es 0 si puede sonar la musica o 1 si no esta cargada y no debe intentar llamar al music_play

u8 continuarPartida; //true si seguimos jugando o false si nos ha matado algo
u8 timeToNextLevel; //0 si estas jugando, un valor mayor que cero tiempo para pasar al siguiente nivel (finalizando nivel)

u8 introPart; //se va a usar para la intro y outtro reutilizadas (la memoria no da pa mas)

u8 lives; //numero de vidas que te quedan
u16 score; //puntuacion
u8 loadsToUpgrade; //numero de cargas que faltan para upgradear el arma
u8 weaponLevel; //nivel actual del arma

u8 cadenaDrawString[256]; //contiene la cadena a pintar con drawString
u8 *cadenaDrawStringCopia; //esto es para no joder la cadena original
u8 cadenaWaitToShow; //contiene un contador que si es cero empieza a meter la cadena cadenaDrawStringPrepare en cadenaDrawString
u8 gra_minifont2[59 * 6]; //contiene el minifont volteado para que cada letra tenga todos los bytes juntos

u8 indexMarcador; //esta variable es para que el marcador vaya rotando la info de todo


u16 hiscore1;  // ESTO ES PARA ALMACENAR EL HI-SCORE (solo pongo 3, no creo que jueguen mas de 3 a esta mierda de juego...)
u16 hiscore2;
u16 hiscore3;
u8 initials1[4];
u8 initials2[4];
u8 initials3[4];


u8 redrawNave=0;  //si es 1 se redibujara la nave del prota


//-------------------------------------------------ENEMIGOS / DISPAROS----------------------------------------------
//16 bytes
struct gameObjectStruct {   //si w es cero el objeto esta inactivo y pasamos de el para todo
	u8 type; //tipo de objeto, para en las colisiones saber con que karajo estas colisionando
    u8 x;  //en bytes ojo
	u8 y;  //este si en pixels
	u8 w; //esto debe apuntar al byte final (al mover la x mover esto tambien y al crearla desplazar w tantos bytes como ancho tenga)
	u8 h; //esto es el desplazamiento tambien, en este caso en pixels, apuntar al ultimo pixel
	u8* bytePtr;  //puntero al byte donde se esta dibujando
	void (*ptrStepFunc)(u8);  //puntero a la funcion 
	void (*ptrColisionFunc)(u8,u8); //puntero a la funcion que entrara cuando colisione o 0 si no se necesita hacer nada
	u8 aux1;   //variables multiusos
	u8 aux2;
	u8 aux3;
	i8 aux4;  //multiusos pero con signo, alguna vez puede hacer falta
	i8 aux5;
};

typedef struct gameObjectStruct gameObject;

#define MAXOBJECTS 30

gameObject listaObjetos[MAXOBJECTS];    //metemos uno mas para que acabe en un objeto con type=0 trucos de optimizacion 
//gameObject auxGameObject;
gameObject gobjToInsert;


//los 4 primeros en teoria no deberian usarse
//va del 6 al 1 (osea estan al reves, la ultima es la que se ve mas arriba, y la primera la que se ve mas abajo, no te lies)
const u8 greatPalete[28]={
0x44, col255_0_255, col128_0_255, col128_0_128, //NO SE USA ESTA LINEA
0x44, col255_0_255, col128_0_255, col128_0_128,
0, 0, 0, 0,
0, 0, 0, 0,
0, 0, 0, 0,
0, 0, 0, 0,
0x44, 0x4B, 0x4E, 0x57
}; 
 

//const u8 menuPalete[4]={col0_0_128, col255_255_255,  col255_0_0, col128_0_0 };
 
 

u8 shakeForce;  //shakeForce debe estar entre 50 izq a 42 derecha , siendo 46 el centro de la pantalla
u8 shakeTime;   //shakeTime tiempo que debe estar shakeando, si llega a 0 se pone shakeForce a 46
 


 
//funciones metodos

void iniciarListasSprites();  //inicia la lista de sprites para animaciones
 
void intro();  
//void outtro();
void menuPrincipal();  
void partida();     
void gameOver();    
void prepararNivel();    //hace los preparativos para empezar un nivel

void moverLogicaJuego();   //mueve las naves enemigos y el prota y los disparos 
void moverLogicaJuegoCheckCollision();  //chequea todas las colisiones y si es necesario lanza el evento colision

void rellenarMarcadorDatos(); //si ve el marcador vacio va enviando textos con datos de la partida

void dibujaPuntuacionRank(u8 *nombre, u16 puntos, u8 y, u8 x); //dibuja un puesto del ranking



void insertObject(u8 type, u8 x, u8 y, u8 w, u8 h, void (*stepfunc)(u8),void (*colifunc)(u8,u8) ,u8 aux1, u8 aux2, u8 aux3, i8 aux4, i8 aux5); //inserta un objeto, se usa para ahorrar codigo

void moverEscenarioEstrellas(); //hace las funciones secundarias, mover escenario, mover estrellas, reordenar objetos, etc
void procesaOptCode();  //pilla el opt code por el que vaya y crea lo ke sea necesario

u8 findFreeGameObject(); //busca un hueco libre en la lista de objetos, si no hay hueco devuelve 0 o false
u8 findProtaIndex(); //busca en que indice esta el prota, se va a usar para la IA
u8 findEnemyIndex(u8 px); //busca en que indice esta el prota, se va a usar para la IA

void controllerNaveProta(u8 o1);   //mueve la nave del prota
void collisionNaveProta(u8 o1,u8 o2);  //evento colision de la nave del prota

void pierdeVida(u8 o1);  //funcion que se llama cuando alguien nos mata (crea la explosion final)

void controllerShootProta(u8 o1);  //mueve el disparo del prota
//void collisionShootProta(u8 o1, u8 o2); //colision con el disparo normal

void controllerShootProtaPlasma(u8 o1);  //mueve el disparo plasma del prota
void dividePlasma(u8 o1);
//void collisionShootProtaPlasma(u8 o1, u8 o2); //colision de la plasma

void controllerShootProtaPlasmaMini(u8 o1);  //mueve el disparo plasma mini del prota

void controllerShootProtaRocket(u8 o1); //mueve el disparo rocket

void controllerEXPLO1(u8 o1);  //mueve una explosion

void explodeMe(u8 o1); //cambia el objeto para que sea una explosion

void controllerENEM1(u8 o1);   //controlador ENEM1, nave simple que avanza en modo kamikaze
void collisionENEM1(u8 o1,u8 o2);

void controllerENEM2(u8 o1);  //controlador ENEM2, torreta fija que dispara desde el suelo
void collisionENEM2(u8 o1,u8 o2);

void controllerENEM3(u8 o1);  //controlador ENEM3, jumper
void collisionENEM3(u8 o1,u8 o2);

void controllerBOSS1(u8 o1);  //controlador BOSS1, jefe final 1, super cruiser lanza cohetes a saco
void collisionBOSS1(u8 o1,u8 o2);

void controllerBOSS2(u8 o1);  //controlador BOSS2, jefe final 2, carrito porculero que da vueltas al escenario
void collisionBOSS2(u8 o1,u8 o2);

void controllerBOSS3(u8 o1);  //controlador BOSS2, jefe final 2, carrito porculero que da vueltas al escenario
void collisionBOSS3(u8 o1,u8 o2);

void controllerENEM4(u8 o1);  //controlador ENEM4, meteorito (va hacia la izquierda a velocidad variable random) puede desviarse un poco
void collisionENEM4(u8 o1,u8 o2);

void controllerENEM6(u8 o1);  //controlador ENEM6, black hole, no se puede eliminar y va absorviendo todo lo que anda cerca
void collisionENEM6(u8 o1,u8 o2);

void controllerENEM7(u8 o1);  //controlador ENEM7, worm hole, si entras por uno sales por el otro, no se puede eliminar
void collisionENEM7(u8 o1,u8 o2);




void enemyCreateShot(u8 enemigo,i8 offsetX,i8 offsetY); //esto es para que los enemigos disparen
void enemyCreateShotRocket(u8 enemigo,i8 offsetX,i8 offsetY); //esto es para que los enemigos disparen cohetes
void enemyCreateItem(u8 enemigo,i8 offsetX,i8 offsetY); //esto es para que los enemigos suelten items al palmar
void checkItemCreate(u8 enemigo,i8 offsetX,i8 offsetY); //esta funcion mira si se tiene que crear un item o no hace falta

void controllerSHOT1(u8 o1);  //controlador de disparo enemigo

void controllerScript(u8 o1); //controlador de scripts, se comporta como enemigo pero no dibuja nada ni debe tocar nada

void cleanKilledObject(u8 o1);  //limpia de la pantalla el objeto que se le diga (llamar antes de type=0)

//void createItemFromObject(u8 o1,u8 itemid,void (*ptrStepFuncion)(u8));  //crea un item donde esta el objeto indicado
void controllerITEMS(u8 o1);  //controlador de los items (simplemente se va moviendo a una velocidad constante, no colis)
void collisionITEMS(u8 o1,u8 o2); //controlador de colision de los items

//void loadAndScrollImage(u8* data,u8 xbytes, u8 yoffset);
 

void stringSet(const char *);
void stringAdd(const char *);
void stringAddNumber(u16);
u8 stringPrepare();

void changePalete(u8 idPal, u8 idCol);

void dibujaMarcadorFondo();

//aqui se guardan los mapeos de teclas siempre IZQ, DER, ARR, ABA, FIRE
u16 keyToLeft;
u16 keyToRight;
u16 keyToUp;
u16 keyToDown;
u16 keyToFire;

//u8 boss3taildir[20];  esto no lo vamos a usar de momento




void main(void) {
	//u8 bucle;  
	u8 *memAux;
	u8 *memAuxPtr;
	//-----------------------------------PREPARATIVOS-------------------------------------------
	cpct_disableFirmware();
	cpct_setVideoMode(1);
	//cpct_setPalette(&greatPalete[24],4);
	//cpct_setPalette(menuPalete,4);
	cpct_setBorder(HW_BLACK);
	
	
	
	

	
	for(index=0; index<200; ++index)
	{
		//videoMemLineStart[index]=cpct_getScreenPtr(CPCT_VMEM_START, 0, index); //esto se puede sacar con tablas
		memAux=cpct_getScreenPtr(CPCT_VMEM_START, 0, index);
		memAuxPtr=0xB000+index;
		*memAuxPtr=*(u8*)(&memAux);
		memAuxPtr=0xB100+index;
		*memAuxPtr=*(((u8*)(&memAux))+1);
	}
		
	iniciarListasSprites();
	
	
   
	//-----------------------------------BUCLE PRINCIPAL-------------------------------------------
	//musicMoment=0;
	//musicActivated=1; //DESACTIVADA (hasta que no este cargada alguna musica no se pone a 0 ACTIVADA)
	cpct_waitVSYNC();  
	interruptMoment=7;  //sincronizamos aqui para que empiece correctamente desde el cero
	cpct_setInterruptHandler( interruptHandlerFast );  //   interruptHandler  este es el amigo que cambia las paletas de colores en el momento correcto, para que funcione bien los frames deben estar perfectamente sincronizados
	
	
	
	//cpct_akp_stop();
	cpct_akp_musicInit(g_songmenu);
	//cpct_akp_setFadeVolume(8);
	introPart=0;
	intro();
	
	while(1)
	{
		if(lives==0)
		{
			//musicActivated=1;
			//musicActivated=0; //MUSICA ACTIVADA
			cpct_akp_stop();
			cpct_akp_musicInit(g_songmenu);
			menuPrincipal();
			sceneNumber=1; //cargamos el primer nivel
			sceneActual=scene1tiles; 
			sceneOptActual=scene1opt;
		}
		partida();
		gameOver();
	}
	
	
}








void iniciarListasSprites()
{
	listaSpriteExplosiones[0]=gra_explo2a;
	listaSpriteExplosiones[1]=gra_explo2b;
	listaSpriteExplosiones[2]=gra_explo2c;
	listaSpriteExplosiones[3]=gra_explo2d;
	listaSpriteExplosiones[4]=gra_explo2e;
	
	/*listaSpriteExplosiones[5]=gra_explo2a;
	listaSpriteExplosiones[6]=gra_explo2b;
	listaSpriteExplosiones[7]=gra_explo2c;
	listaSpriteExplosiones[8]=gra_explo2d;
	listaSpriteExplosiones[9]=gra_explo2e;*/
	
	listaSpriteShot1[0]=gra_shot1a;
	listaSpriteShot1[1]=gra_shot1b;
	listaSpriteShot1[2]=gra_shot1c;
	listaSpriteShot1[3]=gra_shot1d;
	
	listaSpriteShot2[0]=gra_shot2a;
	listaSpriteShot2[1]=gra_shot2b;
	listaSpriteShot2[2]=gra_shot2c;
	listaSpriteShot2[3]=gra_shot2d;
	
	
	listaSpriteItem1[0]=gra_itemA;
	listaSpriteItem1[1]=gra_itemB;
	listaSpriteItem1[2]=gra_itemC;
	listaSpriteItem1[3]=gra_itemD;
	
	
	listaSpriteProta[0]=gra_naveE;
	listaSpriteProta[1]=gra_naveEup;
	listaSpriteProta[2]=gra_naveEdown;
	listaSpriteProta[3]=gra_engineA;
	listaSpriteProta[4]=gra_engineB;
	listaSpriteProta[5]=gra_engineC;
	listaSpriteProta[6]=gra_engineD;
	
	
	//ajustamos el font para usarlo mejor
	for(index=0; index<59; index++)
	{
		gra_minifont2[(index*6)+0]=gra_minifont[0+index];
		gra_minifont2[(index*6)+1]=gra_minifont[59+index];
		gra_minifont2[(index*6)+2]=gra_minifont[118+index];
		gra_minifont2[(index*6)+3]=gra_minifont[177+index];
		gra_minifont2[(index*6)+4]=gra_minifont[236+index];
		gra_minifont2[(index*6)+5]=gra_minifont[295+index];
	}
	
	listaSpriteRocket[0]=gra_rocket0a;
	listaSpriteRocket[1]=gra_rocket0b;
	listaSpriteRocket[2]=gra_rocket0c;
	listaSpriteRocket[3]=gra_rocket0d;
	
	listaSpriteRocket[4]=gra_rocket2a;
	listaSpriteRocket[5]=gra_rocket2b;
	listaSpriteRocket[6]=gra_rocket2c;
	listaSpriteRocket[7]=gra_rocket2d;
	
	listaSpriteRocket[8]=gra_rocket4a;
	listaSpriteRocket[9]=gra_rocket4b;
	listaSpriteRocket[10]=gra_rocket4c;
	listaSpriteRocket[11]=gra_rocket4d;
	
	listaSpriteRocket[12]=gra_rocket6a;
	listaSpriteRocket[13]=gra_rocket6b;
	listaSpriteRocket[14]=gra_rocket6c;
	listaSpriteRocket[15]=gra_rocket6d;
	
	/*listaSpriteHoles[0]=gra_blackholeA;
	listaSpriteHoles[1]=gra_blackholeB;
	listaSpriteHoles[2]=gra_blackholeC;
	listaSpriteHoles[3]=gra_blackholeD;
	
	listaSpriteHoles[4]=gra_wormhole1a;
	listaSpriteHoles[5]=gra_wormhole1b;
	listaSpriteHoles[6]=gra_wormhole1c;
	listaSpriteHoles[7]=gra_wormhole1d;
	
	listaSpriteHoles[8]=gra_wormhole2a;
	listaSpriteHoles[9]=gra_wormhole2b;
	listaSpriteHoles[10]=gra_wormhole2c;
	listaSpriteHoles[11]=gra_wormhole2d;*/
	
	
	//ya de paso limpio los hi-scores
	hiscore1=300;  // ESTO ES PARA ALMACENAR EL HI-SCORE (solo pongo 3, no creo que jueguen mas de 3 a esta mierda de juego...)
	hiscore2=200;
	hiscore3=100;
	initials1[0]='I'; initials1[1]='R'; initials1[2]='A'; initials1[3]=0;
	initials2[0]='S'; initials2[1]='P'; initials2[2]='C'; initials2[3]=0;
	initials3[0]='C'; initials3[1]='W'; initials3[2]='B'; initials3[3]=0;
	
	keyToLeft=Key_O;
	keyToRight=Key_P;
	keyToUp=Key_Q;
	keyToDown=Key_A;
	keyToFire=Key_Space;
}
 


 
 
 
 

void intro()
{
	u8 r;
	u8 next;
	u8 second;
	/*  SYSTEM YEAR: 4353. THE GUARDIANS OF THE LAW WERE NOT ABLE TO CONTROL 
ALL THE CORRUPTION OF THE GALAXY. TO ALLEVIATE THIS SITUATION THEY 
CREATED THE SYSTEM OF REWARDS FOR CAPTURES OF WANTED PEOPLE. THESE 
HUNTERS PEOPLE WERE CALLED SPACE COWBOYS. UNFORTUNATELY, ORGANIZED 
CRIME DEVELOPED A SPY VIRUS THAT SPREAD THROUGHOUT THE GALAXY. USING 
THE INFORMATION THEY CREATED ROBOTS THAT SEEK AND DESTROY THE COWBOYS.  */
	
	changePalete(0, col0_0_0);
	changePalete(1, col255_255_255);
	changePalete(2, col255_128_0);
	changePalete(3, col128_0_0);
	
	punteroDeLaMuerte=&greatPalete[4];
	*punteroDeLaMuerte=col0_0_0;
	
	
	
	while(introPart==0 || introPart==1 || introPart==10)
	{
		//aqui va lo ke deba salir en la intro
		if(introPart==0)
		{
			stringSet(" SYSTEM YEAR: 4353. THE GUARDIANS OF THE LAW WERE NOT ABLE TO CONTROL ");
			vmdy=104; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet("  ALL THE CORRUPTION OF THE GALAXY. TO ALLEVIATE THIS SITUATION THEY  ");
			vmdy=120; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet("  CREATED THE SYSTEM OF REWARDS FOR CAPTURES OF WANTED PEOPLE. THESE  ");
			vmdy=136; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet("  HUNTERS PEOPLE WERE CALLED SPACE COWBOYS. UNFORTUNATELY, ORGANIZED  ");
			vmdy=152; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet(" CRIME DEVELOPED A SPY VIRUS THAT SPREAD THROUGHOUT THE GALAXY. USING ");
			vmdy=168; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet("THE INFORMATION THEY CREATED ROBOTS THAT SEEK AND DESTROY THE COWBOYS.");
			vmdy=184; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
		}else if(introPart==1){
			stringSet("NOW, THE WHOLE GALAXY IS FULL OF KILLER ROBOTS. COWBOY DANTE TRIES TO ");
			vmdy=104; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet("HUNT ZER0, THE CRIMINAL WITH THE GREATEST REWARD. THE GUARDIANS BELIEVE");
			vmdy=120; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet("THAT HE IS THE HEAD OF THE ENTIRE ORGANIZATION AND HIS ARREST IS VITAL");
			vmdy=136; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet("    TO STOP THE DISASTER. HACKER MARIAHZ HAS ENTRUSTED DANTE WITH     ");
			vmdy=152; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet("     INFORMATION ABOUT THE LAST LOCATION WHERE ZER0 WAS SEEN.         ");
			vmdy=168; getvmd(); 
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
			stringSet("       DANTE HAS STARTED HIS WAY, IT'S TIME TO KILL ZER0.             ");
			vmdy=184; getvmd();
			punteroDeLaMuerte=vmdptr+4;
			drawString2();
		}else{
			//este es el outtro
			stringSet("                  YOU HAVE FINISHED WITH ZER0.                 ");
			vmdy=104; getvmd();
			punteroDeLaMuerte=vmdptr+8;
			drawString2();
			stringSet("IT WILL BE A HARD BLOW FOR THE ORGANIZATION. DANTE WILL RECEIVE");
			vmdy=120; getvmd();
			punteroDeLaMuerte=vmdptr+8;
			drawString2();
			stringSet("  A GREAT REWARD TO IMPROVE HIS SHIP AND KEEP FIGHTING CRIME.  ");
			vmdy=136; getvmd();
			punteroDeLaMuerte=vmdptr+8;
			drawString2();
			stringSet("                    SEE YOU SOON COWBOY!                       ");
			vmdy=152; getvmd();
			punteroDeLaMuerte=vmdptr+8;
			drawString2();
			stringSet("            THANKS FOR PLAYING. TO BE CONTINUE...              ");
			vmdy=168; getvmd();
			punteroDeLaMuerte=vmdptr+8;
			drawString2();
		}
		next=20;
		second=50;
		while(next>0)
		{
			second--;
			if(second==0)
			{
				second=50; 
				next=next-1;
			}
			if(second%2==0)
			{
				r=cpct_getRandom_lcg_u8(0);
				if(r<20)
				{
					r=(cpct_getRandom_lcg_u8(0)%60)+10;
					insertObject(100, 76,r , 4, 16,  controllerENEM1,collisionENEM1 ,60,0,0,0,2);
				}
				
				moverLogicaJuego();
				
				cpct_akp_musicPlay();
			}else{
				//mueve estrellas
				r=cpct_getRandom_lcg_u8(0);
				if(r>150)
				{
					r=cpct_getRandom_lcg_u8(0);
					if(r<96)
					{
						//punteroDeLaMuerteStars=&listaStarsMAXIMA[stars2pixIndex];
						punteroDeLaMuerteStars=0xB700+stars2pixIndex;
						vmdy=r; getvmd();
						*(u16*)(punteroDeLaMuerteStars)=(u16)(vmdptr+78);
						punteroDeLaMuerteStars++; punteroDeLaMuerteStars++;
						*punteroDeLaMuerteStars=0;
						punteroDeLaMuerteStars++;
						*punteroDeLaMuerteStars=78;
						stars2pixIndex=stars2pixIndex+4;
						
						if(stars2pixIndex==MAX_STARS_PIX_MUL)
						{
							stars2pixIndex=0;
						}
					}
				}
				//punteroDeLaMuerteStars=(&listaStarsMAXIMA[MAX_STARS_PIX_MUL-1]);
				punteroDeLaMuerteStars=0xB700+MAX_STARS_PIX_MUL-1;
				if(starsMoment==0)
				{
					scroleaStars();   
					starsMoment=1;
				}else{
					scroleaStarsBis();
					starsMoment=0;
				}
			}
			cpct_scanKeyboard();
			if(cpct_isKeyPressed(Key_Space) || cpct_isKeyPressed(Key_Return) || cpct_isKeyPressed(Joy0_Fire1)){
				next=0;
			}		
			cpct_waitVSYNC();
		}
		
		introPart=introPart+1;
	}

	

}

/*void outtro()
{
	u8 ejexAux=0;
	u8 r;
	
	changePalete(0, col128_0_128);
	changePalete(1, col255_255_255);
	changePalete(2, col0_255_0);
	changePalete(3, col0_128_128);
	punteroDeLaMuerte=&greatPalete[4];
	*punteroDeLaMuerte=col0_0_0;
	
	stringSet("                  YOU HAVE FINISHED WITH ZER0.                 ");
	vmdy=104; getvmd();
	punteroDeLaMuerte=vmdptr+8;
	drawString2();
	stringSet("IT WILL BE A HARD BLOW FOR THE ORGANIZATION. DANTE WILL RECEIVE");
	vmdy=120; getvmd();
	punteroDeLaMuerte=vmdptr+8;
	drawString2();
	stringSet("  A GREAT REWARD TO IMPROVE HIS SHIP AND KEEP FIGHTING CRIME.  ");
	vmdy=136; getvmd();
	punteroDeLaMuerte=vmdptr+8;
	drawString2();
	stringSet("                    SEE YOU SOON COWBOY!                       ");
	vmdy=152; getvmd();
	punteroDeLaMuerte=vmdptr+8;
	drawString2();
	stringSet("            THANKS FOR PLAYING. TO BE CONTINUE...              ");
	vmdy=168; getvmd();
	punteroDeLaMuerte=vmdptr+8;
	drawString2();
	
	
	continuarPartida=10;
	index=50;
	while(continuarPartida>0)
	{
		index--;
		if(index==0)
		{
			index=50; continuarPartida--;
		}
		if(index%25==0)
		{
			ejexAux++;
		}
		if(index%2==0)
		{
			//dibuja aqui la nave
			if(GRA_MENUNAVE_W+ejexAux<79)
			{
				vmdy=40; getvmd();
				cpct_drawSprite(gra_menuNave, vmdptr+ejexAux, GRA_MENUNAVE_W, GRA_MENUNAVE_H);
			}
			
			cpct_akp_musicPlay();
		}else{
			//mueve estrellas
			r=cpct_getRandom_lcg_u8(0);
			if(r>150)
			{
				r=cpct_getRandom_lcg_u8(0);
				if(r<96)
				{
					//punteroDeLaMuerteStars=&listaStarsMAXIMA[stars2pixIndex];
					punteroDeLaMuerteStars=0xB700+stars2pixIndex;
					vmdy=r; getvmd();
					*(u16*)(punteroDeLaMuerteStars)=(u16)(vmdptr+78);
					punteroDeLaMuerteStars++; punteroDeLaMuerteStars++;
					*punteroDeLaMuerteStars=0;
					punteroDeLaMuerteStars++;
					*punteroDeLaMuerteStars=78;
					stars2pixIndex=stars2pixIndex+4;
					
					if(stars2pixIndex==MAX_STARS_PIX_MUL)
					{
						stars2pixIndex=0;
					}
				}
			}
			//punteroDeLaMuerteStars=(&listaStarsMAXIMA[MAX_STARS_PIX_MUL-1]);
			punteroDeLaMuerteStars=0xB700+MAX_STARS_PIX_MUL-1;
			if(starsMoment==0)
			{
				scroleaStars();   
				starsMoment=1;
			}else{
				scroleaStarsBis();
				starsMoment=0;
			}
		}
		cpct_scanKeyboard();
		if(cpct_isKeyPressed(Key_Space) || cpct_isKeyPressed(Key_Return) || cpct_isKeyPressed(Joy0_Fire1)){
			continuarPartida=0;
		}		
		cpct_waitVSYNC();
		
	}
}*/






void menuPrincipal()
{
	//u8 modoSimpleLargo=0;  //0 modo simple, 1 modo largo
	//u8 byteDato=0;
	//u8 largo=0;
	u8 x=0;
	u8 y=0;
	u8 r=0;
	u8 text=0;
	u8* bright1ptr=0xC000; //para el sprite del destello
	u8 bright1s=1;
	u8* bright2ptr=0xC000; //para el sprite del destello
	u8 bright2s=3;
	u8* bright3ptr=0xC000; //para el sprite del destello
	u8 bright3s=5;
	u8 key2hooked=0;  //es para que tengas ke soltar el 2 para cambiar de controles
	
	//aqui todo el menu principal (start, define controls, etc)
	//pintamos el dibujo del menu
	cpct_memset(CPCT_VMEM_START, 0, 0x4000 );
	
	
	//configuramos la paleta
/*	greatPalete[28]={
		col255_0_0, col255_0_255, col128_0_255, col128_0_128, //NO SE USA ESTA LINEA
		col0_255_0, col255_0_255, col128_0_255, col128_0_128,
		0, 0, 0, 0,
		0, 0, 0, 0,
		0, 0, 0, 0,
		0, 0, 0, 0,
		0x44, 0x4B, 0x4E, 0x57
		};*/
	
	
	//la de antes  (letras de abajo)
	punteroDeLaMuerte=&greatPalete[4];
	*punteroDeLaMuerte=col0_0_128;     punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_255_255; punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_0_0;     punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_0_128;   punteroDeLaMuerte++;
	
	//penultima linea (el agua molona)
	*punteroDeLaMuerte=col0_0_128;     punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_255_255; punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_255_128; punteroDeLaMuerte++;
	*punteroDeLaMuerte=col128_0_128;   punteroDeLaMuerte++;
	
	//ultima linea (la colina y la nave y dante)
	*punteroDeLaMuerte=col0_0_0;     punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_255_255; punteroDeLaMuerte++;
	*punteroDeLaMuerte=col128_128_128; punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_128_0;   punteroDeLaMuerte++;
	
	//ultima linea  (el sombrero y el menu)
	*punteroDeLaMuerte=col0_0_0;     punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_255_255; punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_0_0; punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_128_0;   punteroDeLaMuerte++;
	
	//ultima linea  ( las letras del titulo)
	*punteroDeLaMuerte=col0_0_0;     punteroDeLaMuerte++;
	*punteroDeLaMuerte=col128_0_255; punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_0_0; punteroDeLaMuerte++;
	*punteroDeLaMuerte=col255_255_0;   punteroDeLaMuerte++;
	
	//dibujamos el fondillo
	//de 140 pa bajo
	
	vmdy=128; getvmd();
	cpct_drawSolidBox(vmdptr, 255, 20, 64);
	vmdy=140; getvmd();
	cpct_drawSolidBox(vmdptr+19, 0, 1, 52);
	vmdy=150; getvmd();
	cpct_drawSolidBox(vmdptr+18, 0, 2, 42);
	vmdy=160; getvmd();
	cpct_drawSolidBox(vmdptr+17, 0, 3, 32);
	vmdy=170; getvmd();
	cpct_drawSolidBox(vmdptr+16, 0, 4, 22);
	vmdy=106; getvmd();
	cpct_drawSprite(gra_menuNave, vmdptr+3, GRA_MENUNAVE_W, GRA_MENUNAVE_H);
	vmdy=84; getvmd();
	cpct_drawSprite(gra_menuDante, vmdptr+12, GRA_MENUDANTE_W, GRA_MENUDANTE_H);

	
	vmdy=5; getvmd();
	cpct_drawSprite(gra_titleUp, vmdptr+30, GRA_TITLEUP_W, GRA_TITLEUP_H);
	vmdy=5; getvmd();
	cpct_drawSprite(gra_moon, vmdptr+66, GRA_MOON_W, GRA_MOON_H);
	
	
	
	dibujaMarcadorFondo();
	
	
	
	
	
	
	
	
	
	
	stringSet("1 - START GAME       ");
	vmdy=48; getvmd();
	punteroDeLaMuerte=vmdptr+30;
	drawString2();
			
	r=cpct_getRandom_lcg_u8(0)%2;
	if(r)
	{
		stringSet("2 - CONTROLS: OPQA SPACE  ");
	}else{
		stringSet("2 - CONTROLS: QAOP SPACE  ");
	}
	vmdy=64; getvmd();
	punteroDeLaMuerte=vmdptr+32;
	drawString2();
	
			
	dibujaPuntuacionRank(initials1, hiscore1, 96, 36);
	dibujaPuntuacionRank(initials2, hiscore2, 112, 38);	
	dibujaPuntuacionRank(initials3, hiscore3, 128, 40);


	
	
	 
	continuarPartida=1;
	while(continuarPartida)
	{
		//mueve estrellas
		r=cpct_getRandom_lcg_u8(0);
		if(r>150)
		{
			r=cpct_getRandom_lcg_u8(0);
			if(r<140)
			{
				//punteroDeLaMuerteStars=&listaStarsMAXIMA[stars2pixIndex];
				punteroDeLaMuerteStars=0xB700+stars2pixIndex;
				vmdy=r; getvmd();
				*(u16*)(punteroDeLaMuerteStars)=(u16)(vmdptr+78);
				punteroDeLaMuerteStars++; punteroDeLaMuerteStars++;
				*punteroDeLaMuerteStars=0;
				punteroDeLaMuerteStars++;
				*punteroDeLaMuerteStars=78;
				stars2pixIndex=stars2pixIndex+4;
				
				if(stars2pixIndex==MAX_STARS_PIX_MUL)
				{
					stars2pixIndex=0;
				}
			}
		}
		//punteroDeLaMuerteStars=(&listaStarsMAXIMA[MAX_STARS_PIX_MUL-1]);
		punteroDeLaMuerteStars=0xB700+MAX_STARS_PIX_MUL-1;
		if(starsMoment==0)
		{
			scroleaStars();   
			starsMoment=1;
		}else{
			scroleaStarsBis();
			starsMoment=0;
		}
		
		bright1s++;
		if(bright1s>6)
		{
			bright1s=0;
			x=cpct_getRandom_lcg_u8(0)%80;
			while(x<20)
			{
				x=cpct_getRandom_lcg_u8(0)%80;
			}
			y=cpct_getRandom_lcg_u8(0)%50;
			while(y<20)
			{
				y=cpct_getRandom_lcg_u8(0)%50;
			}
			vmdy=y+140; getvmd();
			bright1ptr=vmdptr+x;
		}
		*bright1ptr=gra_bright[bright1s];
		
		bright2s++;
		if(bright2s>6)
		{
			bright2s=0;
			x=cpct_getRandom_lcg_u8(0)%80;
			while(x<20)
			{
				x=cpct_getRandom_lcg_u8(0)%80;
			}
			y=cpct_getRandom_lcg_u8(0)%50;
			while(y<20)
			{
				y=cpct_getRandom_lcg_u8(0)%50;
			}
			vmdy=y+140; getvmd();
			bright2ptr=vmdptr+x;
		}
		*bright2ptr=gra_bright[bright2s];
		
		bright3s++;
		if(bright3s>6)
		{
			bright3s=0;
			x=cpct_getRandom_lcg_u8(0)%80;
			while(x<20)
			{
				x=cpct_getRandom_lcg_u8(0)%80;
			}
			y=cpct_getRandom_lcg_u8(0)%50;
			while(y<20)
			{
				y=cpct_getRandom_lcg_u8(0)%50;
			}
			vmdy=y+140; getvmd();
			bright3ptr=vmdptr+x;
		}
		*bright3ptr=gra_bright[bright3s];
		
	
		
		
		
		
		cpct_waitVSYNC(); 
		
		//controla opciones del menu y mueve chequea teclado
		
		if(cadenaDrawString[0]==0 || cadenaDrawString[1]==0)
		{
			if(text==0)
			{
				stringAdd("< VOXEL TOWER 2018 PRESENTS SPACE COWBOY >  ");
				text=1;
			}else if(text==1){
				stringAdd("< A ISRAEL ROMAN GAME TO CPCRETRODEV >  ");
				text=2;
			}else if(text==2){
				stringAdd("< VOXELTOWER@GMAIL.COM >  ");
				text=0;
			}
		}
		
		stringPrepare();
		cpct_scanKeyboard();
		
		if(cpct_isKeyPressed(Key_1)){
			continuarPartida=0;
		}
		
		if(cpct_isKeyPressed(Key_2))
		{
			if(key2hooked==0)
			{
				key2hooked=1;
				
				//guardamos la cadena original
				cadenaDrawStringCopia=0xB200;
				for(r=0; r<255; r++)
				{
					*cadenaDrawStringCopia=cadenaDrawString[r];
					cadenaDrawStringCopia++;
				}
				
				//rotar controles
				if(keyToLeft==Key_O){
					keyToLeft=Joy0_Left;
					keyToRight=Joy0_Right;
					keyToUp=Joy0_Up;
					keyToDown=Joy0_Down;
					keyToFire=Joy0_Fire1;
					stringSet("2 - CONTROLS: JOYSTICK  ");
				}else if(keyToLeft==Joy0_Left){
					keyToLeft=Key_A;
					keyToRight=Key_D;
					keyToUp=Key_W;
					keyToDown=Key_S;
					keyToFire=Key_Return;
					stringSet("2 - CONTROLS: WASD RETURN  ");
				}else if(keyToLeft==Key_A){
					keyToLeft=Key_CursorLeft;
					keyToRight=Key_CursorRight;
					keyToUp=Key_CursorUp;
					keyToDown=Key_CursorDown;
					keyToFire=Key_Space;
					stringSet("2 - CONTROLS: CURSOR SPACE  ");
				}else{
					keyToLeft=Key_O;
					keyToRight=Key_P;
					keyToUp=Key_Q;
					keyToDown=Key_A;
					keyToFire=Key_Space;
					r=cpct_getRandom_lcg_u8(0)%2;
					if(r)
					{
						stringSet("2 - CONTROLS: OPQA SPACE  ");
					}else{
						stringSet("2 - CONTROLS: QAOP SPACE  ");
					}
				}
				
				//repintamos los controles
				vmdy=64; getvmd();
				punteroDeLaMuerte=vmdptr+32;
				drawString2();
				
				//recupero la cadena
				cadenaDrawStringCopia=0xB200;
				for(r=0; r<255; r++)
				{
					cadenaDrawString[r]=*cadenaDrawStringCopia;
					cadenaDrawStringCopia++;
				}
			}
		}else{
			key2hooked=0;
		}
		

		cpct_waitVSYNC(); 
		cpct_akp_musicPlay();
	}
	
	cpct_akp_stop();
	
	//dejamos las variables iniciales preparadas
	lives=3; //numero de vidas que te quedan
	indexMarcador=2;
	
	//cpct_setPalette(&greatPalete[24],4);
}


void dibujaPuntuacionRank(u8 *nombre, u16 puntos, u8 y, u8 x)
{
	cadenaDrawString[0]=nombre[0]; cadenaDrawString[1]=nombre[1]; cadenaDrawString[2]=nombre[2];cadenaDrawString[3]=0;
	stringAdd(" ........ ");
	stringAddNumber(puntos);
	stringAdd("             ");
	vmdy=y; getvmd();
	punteroDeLaMuerte=vmdptr+x;
	drawString2();
}







void partida()
{
	loadsToUpgrade=3; //numero de cargas que faltan para upgradear el arma
	weaponLevel=0; //nivel actual del arma

	//aqui el loop de la partida
	continuarPartida=1; 
	timeToNextLevel=0;

	//musicActivated=1;  //DESACTIVAMOS MUSICA
	cpct_akp_stop();
	cpct_akp_musicInit(g_songgame);
	cpct_akp_SFXInit(g_songgame);
	//musicActivated=0;  //ACTIVAMOS MUSICA

	//cpct_akp_SFXInit(g_songgame);
	

	prepararNivel();

	//cpct_setBorder(HW_BLACK);
	
	moment=0;
	starsMoment=0;
	while(continuarPartida)
	{
		if(shakeTime>0)
		{
			shakeTime--;
			if(shakeTime>3)
			{
				shakeForce=44 + (cpct_getRandom_lcg_u8(0) % 5);
			}else{
				shakeForce=45 + (cpct_getRandom_lcg_u8(0) % 3);
			}
		}else{
			shakeForce=46;
		}
		shakeIt();
		
		
		
		
		//frame 0,2,4,6: cargaEscenario  mueveestrellas  mueveescenario    ajustacolisiones  
		moverEscenarioEstrellas();
		//cpct_setBorder(HW_BLACK);

		
		

		cpct_waitVSYNC();   
		//interruptMoment=6;
		moment++;
		
		
		
		
		//frame 1,3,5,7: movemos la nave, los enemigos, los disparos
		moverLogicaJuego();
		//cpct_setBorder(HW_BLACK);
		
		if(timeToNextLevel>0)
		{
			timeToNextLevel--;
			if(timeToNextLevel==0)
			{
				//pasamos al siguiente nivel
				if(sceneNumber==3)
				{
					sceneNumber=4;
					introPart=10;
					intro();
					score=score+(lives*1000);
					lives=0;
					continuarPartida=0;
					//outtro(); //te has pasado el juego, al karajo...
				}
				if(sceneNumber==2)
				{
					sceneNumber=3;
					sceneActual=scene3tiles;
					sceneOptActual=scene3opt;
					prepararNivel();
				}
				if(sceneNumber==1)
				{
					sceneNumber=2;
					sceneActual=scene2tiles;
					sceneOptActual=scene2opt;
					prepararNivel();
				}
			}
		}
		
		cpct_waitVSYNC();
		//suena la musikita
		cpct_akp_musicPlay();
		//interruptMoment=6;
		moment++;

		if(moment==8)
		{
			moment=0;
		}

		
		
	}
	
	//colisionIndex=cpct_removeInterruptHandler(); //aluckardo hace falta??? creo que no
}






void gameOver()
{ 
	u8 r;
	u8 ind;
	u8 ind2;
	
	u8 initialsRecord[4];
	
	u16 keysCodes[26]={Key_A, Key_B, Key_C, Key_D, Key_E, Key_F, Key_G, Key_H, Key_I, Key_J, 
					   Key_K, Key_L, Key_M, Key_N, Key_O, Key_P, Key_Q, Key_R, Key_S, Key_T, 
					   Key_U, Key_V, Key_W, Key_X, Key_Y, Key_Z};
	
	//aqui la scenecut del gameover si hay
	cpct_akp_stop();
	continuarPartida=1;
	stringSet("");
	if(lives==0)
	{
		r=cpct_getRandom_lcg_u8(0) % 4;
		if(r==0){
			stringAdd(" < GAME OVER COWBOY, NOW YOU ARE FOOD FOR WORMS >   ");
		}else if(r==1){
			stringAdd(" < GAME OVER COWBOY, YOU ARE ERASED OF THIS GALAXY >   ");
		}else if(r==2){
			stringAdd(" < GAME OVER COWBOY, YOUR PLACE IS SIX FEET UNDER >   ");
		}else if(r==3){
			stringAdd(" < GAME OVER COWBOY, THIS REWARD IS NOT FOR YOU >   ");
		}
		
	}else{
		r=cpct_getRandom_lcg_u8(0) % 4;
		if(r==0){
			stringAdd(" < MORE LUCK NEXT TIME COWBOY, PRESS FIRE TO CONTINUE >   ");
		}else if(r==1){
			stringAdd(" < NEXT TIME DODGE THE BULLETS, PRESS FIRE TO CONTINUE >   ");
		}else if(r==2){
			stringAdd(" < I EXPECTED MORE FROM YOU, PRESS FIRE TO CONTINUE >   ");
		}else if(r==3){
			stringAdd(" < MY GRANDMOTHER DOES IT BETTER, PRESS FIRE TO CONTINUE >   ");
		}
	}
	
	
	
	ind=1;
	ind2=100;
	while(continuarPartida)
	{
		ind--;
		if(ind==0)
		{
			stringPrepare();
			ind=6;
		}
		cpct_scanKeyboard();
		ind2--;
		if(ind2==0)
		{
			ind2++;
			if(cpct_isKeyPressed(keyToFire))
			{
				continuarPartida=0;
			}
		}
		cpct_waitVSYNC();
	}
	
	//si ponemos nombre...
	if(lives==0)
	{
		if(hiscore3<score)
		{
			ind=0;ind2=0;
			continuarPartida=1;
			stringSet("WOW ");
			stringAddNumber(score);
			stringAdd(" POINTS!!, ENTER YOUR INITIALS: ");
			initialsRecord[0]=0; initialsRecord[1]=0; initialsRecord[2]=0;initialsRecord[3]=0;
			while(continuarPartida)
			{
				cpct_scanKeyboard();
				if(ind2==0)
				{
					for(r=0; r<26; r++)
					{
						if(cpct_isKeyPressed(keysCodes[r]))
						{
							initialsRecord[ind]=(r+65);
							stringAdd(&initialsRecord[ind]); //anado la ultima letra solo (como la siguiente es cero es lo que va a anadir)
							ind=ind+1;
							if(ind==3)
							{
								ind2=150;
							}
							while(cpct_isKeyPressed(keysCodes[r]))
							{
								cpct_scanKeyboard();
								cpct_waitVSYNC();
							}
						}
					}
				}
				vmdy=96; getvmd();
				punteroDeLaMuerte=vmdptr+12;
				drawString2();
				
				if(ind2>0)
				{
					ind2--;
					if(ind2==1)
					{
						continuarPartida=0;
					}
				}	
				
				
				cpct_waitVSYNC();
			}
			
			if(score>hiscore1)
			{
				//echar patras a los demas  2º pasa al tercero y 1º pasa al segundo
				initials3[0]=initials2[0]; initials3[1]=initials2[1]; initials3[2]=initials2[2]; 
				hiscore3=hiscore2;
				initials2[0]=initials1[0]; initials2[1]=initials1[1]; initials2[2]=initials1[2]; 
				hiscore2=hiscore1;
				for(r=0; r<3; r++)
				{
					initials1[r]=initialsRecord[r];
				}
				hiscore1=score;
			}else if(score>hiscore2){
				//echar pa tras a los demas 2º pasa al tercero
				initials3[0]=initials2[0]; initials3[1]=initials2[1]; initials3[2]=initials2[2]; 
				hiscore3=hiscore2;
				for(r=0; r<3; r++)
				{
					initials2[r]=initialsRecord[r];
				}
				hiscore2=score;
			}else{
				for(r=0; r<3; r++)
				{
					initials3[r]=initialsRecord[r];
				}
				hiscore3=score;
			}
		}
	}
}


void prepararNivel()
{
	//limpiamos la pantalla
	cpct_memset(CPCT_VMEM_START, 0, 0x4000 );
	
	//limpiamos los arrays del nivel
	for(scene2pixIndex=0;scene2pixIndex<MAX_SCENE_PIX_MUL;scene2pixIndex++)
	{
		//listaSceneMAXIMA[scene2pixIndex]=0;
		punteroDeLaMuerte=0xB800+scene2pixIndex;
		*punteroDeLaMuerte=0;
	}
	
	
	//apuntamos el reparador a 0
	scene2pixIndexFix0=0;
	
	//limpiamos las colisiones
	for(scene2pixIndex=0;scene2pixIndex<640;scene2pixIndex++)
	{
		punteroDeLaMuerte=0xB400+scene2pixIndex;
		*punteroDeLaMuerte=0;
		//sceneCollision[scene2pixIndex]=0;
	}
	for(index=0; index<24; index++)
	{
		listaPrepareCollisions[index]=0;
	}
	
	//limpiamos los objetos
	for(index=0; index<MAXOBJECTS; index++)
	{
		listaObjetos[index].type=0;
	}
	
	//preparamos el loop de carga del nivel
	actualScenePointer=0;
	actualSceneOptPointer=0;
	acumDespSceneOpt=sceneOptActual[actualSceneOptPointer++];
	acumDespScene=1;
	scene2pixIndex=0;
	stopSceneTime=0;
	sceneYoffset=0;
	
	
	
	

	
	//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
	insertObject(1, 5,80, 7,10, 
					controllerNaveProta,collisionNaveProta ,0,0,0,0,0);
	redrawNave=1;
	

	//preparamos el puntero a los tiles y nos desplazamos a donde empieza realmente la info del escenario
	numberTiles=sceneActual[actualScenePointer];
	punteroTiles=sceneActual;
	punteroTiles++;
	actualScenePointer=1+(numberTiles*8);
	
	
	dibujaMarcadorFondo();
}


void dibujaMarcadorFondo()
{
	//pintamos el marcador
	vmdy=192; getvmd();
	punteroDeLaMuerte=vmdptr+4;
	index2=PIX_0_PAL_2+PIX_1_PAL_2+PIX_2_PAL_2+PIX_3_PAL_2;
	for(index=0; index<72; index++)
	{
		*punteroDeLaMuerte=index2;
		punteroDeLaMuerte++;
	}
	vmdy=199; getvmd();
	punteroDeLaMuerte=vmdptr+4;
	index2=PIX_0_PAL_3+PIX_1_PAL_3+PIX_2_PAL_3+PIX_3_PAL_3;
	for(index=0; index<72; index++)
	{
		*punteroDeLaMuerte=index2;
		punteroDeLaMuerte++;
	}
	vmdy=192; getvmd();
	punteroDeLaMuerte=vmdptr;
	cpct_drawSprite(gra_marcadorLeft, punteroDeLaMuerte, GRA_MARCADORLEFT_W, GRA_MARCADORLEFT_H);
	punteroDeLaMuerte=vmdptr+76;	
	cpct_drawSprite(gra_marcadorRight, punteroDeLaMuerte, GRA_MARCADORRIGHT_W, GRA_MARCADORRIGHT_H);
}











void moverLogicaJuegoCheckCollision()
{
	u8 ind3;
	u8 ind2;
	u8 ind1;
	//cpct_setBorder(HW_CYAN);

	ind3=MAXOBJECTS-1;
	for(ind1=0; ind1<ind3; ind1++)
	{
		if(listaObjetos[ind1].type!=0)
		{
			ind2=ind1+1;
			while(listaObjetos[ind2].type!=0 && listaObjetos[ind2].x<=listaObjetos[ind1].x+listaObjetos[ind1].w)
			{
				if(listaObjetos[ind1].x<=listaObjetos[ind2].x+listaObjetos[ind2].w)
				{
					if(listaObjetos[ind1].y<=listaObjetos[ind2].y+listaObjetos[ind2].h)
					{
						if(listaObjetos[ind2].y<=listaObjetos[ind1].y+listaObjetos[ind1].h)
						{
							//aqui hay colision
							if(listaObjetos[ind1].ptrColisionFunc!=0)
							{
								listaObjetos[ind1].ptrColisionFunc(ind1,ind2);
							}
							if(listaObjetos[ind2].ptrColisionFunc!=0 && listaObjetos[ind2].type!=0)
							{
								listaObjetos[ind2].ptrColisionFunc(ind2,ind1);
							}
							
							if(listaObjetos[ind1].type==0)
							{
								break;
							}
						}
					}
				}
				ind2++;
			}
		}
	}
	//cpct_setBorder(HW_BLACK);
}








void rellenarMarcadorDatos()
{
	//si el marcador esta ahora mismo vacio, le metemos algo
	if(cadenaDrawString[0]==0 || cadenaDrawString[1]==0)
	{
		indexMarcador--;
		if(indexMarcador==0)
		{
			indexMarcador=3;
		}
		
		if(indexMarcador==1){
			//space cowboy by voxeltower (israel roman)
			stringAdd("      < SPACE COWBOY BY VOXELTOWER (ISRAEL ROMAN) - CPCRETRODEV 2018 >       ");
		}else if(indexMarcador==2){
			//vidas restantes LIVES: 3
			stringAdd("      < ");
			stringAddNumber(lives);
			stringAdd(" LIVES LEFT - SCORE: ");
			stringAddNumber(score);
			if(sceneNumber==1){
				stringAdd(" - LEVEL: GO OUT >             ");
			}else if(sceneNumber==2){
				stringAdd(" - LEVEL: INFINITY UNIVERSE >             ");
			}else{
				stringAdd(" - LEVEL: SEEK AND DESTROY >             ");
			}
		}else if(indexMarcador==3){
			if(weaponLevel==0)
			{
				stringAdd("      < WEAPON: LASER BEAM - ");
			}else if(weaponLevel==1){
				stringAdd("      < WEAPON: MAGNETIC MISSILE  - ");
			}else if(weaponLevel==2){
				stringAdd("      < WEAPON: PLASMA CANNON - ");
			}else if(weaponLevel==3){
				stringAdd("      < WEAPON: DOUBLE LASER BEAM - ");
			}else if(weaponLevel==4){
				stringAdd("      < WEAPON: DOUBLE MAGNETIC MISSILE - ");
			}else if(weaponLevel==5){
				stringAdd("      < WEAPON: DOUBLE PLASMA CANNON - ");
			}
			stringAddNumber(loadsToUpgrade);
			stringAdd(" LOADS TO WEAPON UPGRADE >     ");
		}
	}
}









void moverLogicaJuego()
{
	//cpct_setBorder(HW_LIME);
	
	for(index=MAXOBJECTS-1; index; --index)
	{
		if(listaObjetos[index].type!=0)
		{
			//si esta activo el objeto lo movemos
			listaObjetos[index].ptrStepFunc(index);
		}
	}
	if(listaObjetos[0].type!=0)
	{
		listaObjetos[0].ptrStepFunc(0);
	}
}










void moverEscenarioEstrellas()
{
	u8 r;
	u8 aux;
	u8 save1;
	u8 save2;
	
	//BORDES GREEN moviendoLogica BLUE cargandoescenario RED scroleandoescenario 
	//						YELLOW configurandocolis WHITE scroleandoestrellas
	//0-HW_BRIGHT_BLUE cargaEscenario y reordenoObj         1-GREEN logicaJuego 
	//2-WHITE   mueveestrellas y cargaOpt y colisionObj     7-GREEN logicajuego
	//4-HW_BRIGHT_RED  mueveescenario                                 3-GREEN logicajuego
	//6-HW_BRIGHT_YELLOW  ajustacolisiones y colisionObj  			5-GREEN logicajuego 
	
	
	if(moment==0){
		//-------------------------------------------------------------------------------
		//---CARGAMOS ESCENARIO Y SI NO HAY NADA QUE CARGAR REORDENO TODO LO QUE PUEDA---
		//-------------------------------------------------------------------------------
		//cpct_setBorder(HW_BRIGHT_BLUE); 
		
		if(stopSceneTime==0)
		{
		
			acumDespScene--;

			if(acumDespScene==0)
			{
				aux=sceneActual[actualScenePointer++]; //tenemos que cargar más mierdas
				while(aux<201)
				{
					if(aux==200)
					{
						//esto seria el fin, no habria que cargar nada mas 
						aux=255;
						actualScenePointer=actualScenePointer-1; //hacemos que haga un bucle absurdo para que no se pare al llegar al final
						break;
					}else{
   
						lastColor=sceneActual[actualScenePointer++]; //tile
						
						//listaSceneMAXIMA[scene2pixIndex]=lastColor;
						punteroDeLaMuerte=0xB800+scene2pixIndex;
						*punteroDeLaMuerte=lastColor;
						
						scene2pixIndex++;
						
						//*(u16*)(&listaSceneMAXIMA[scene2pixIndex])=(u16)(videoMemLineStart[aux]+0);
						punteroDeLaMuerte++;
						vmdy=aux; getvmd();
						*(u16*)(punteroDeLaMuerte)=(u16)(vmdptr+0);
						
						scene2pixIndex++; scene2pixIndex++;
						
						//listaSceneMAXIMA[scene2pixIndex]=80;
						punteroDeLaMuerte++;punteroDeLaMuerte++;
						*punteroDeLaMuerte=80;
						
						
						scene2pixIndex++;
						if(scene2pixIndex==MAX_SCENE_PIX_MUL)
						{
							scene2pixIndex=0;  // aqui empieza el cachondeito
						}
						
						//aqui metemos en listaPrepareCollisions[24] aux/4 a 1 para saber que ahi tiene ke ponerse una colision
						if(lastColor>0)
						{
							listaPrepareCollisions[aux/8]=1;
						}else{
							listaPrepareCollisions[aux/8]=0;
						}
						
						aux=sceneActual[actualScenePointer++]; //tenemos que cargar más mierdas

					}
				}
				acumDespScene=(aux-200);
			}else{
				reorderObjectsUltra();
			}
		}else{
			reorderObjectsUltra();
		}
		
		rellenarMarcadorDatos();
		stringPrepare();
	}else if(moment==2){
		
		//---------------------------------------------------------------------
		//---SCROLL BACKGROUND STARS Y CARGA DE OPT Y CHECK COLISION OBJETOS---
		//---------------------------------------------------------------------
		//cpct_setBorder(HW_WHITE); 
		
		
		//COMPROBAMOS SI ESTAMOS PARADOS O NO
		if(stopSceneTime>0)
		{
			stopSceneTime--; 
		}else{
		
			r=cpct_getRandom_lcg_u8(0);
			if(r>200)
			{
				r=cpct_getRandom_lcg_u8(0);
				if(r<200)
				{
					//*(u16*)(&listaStarsMAXIMA[stars2pixIndex])=(u16)(videoMemLineStart[r]+78);
					punteroDeLaMuerteStars=0xB700+stars2pixIndex;
					vmdy=r; getvmd();
					*(u16*)(punteroDeLaMuerteStars)=(u16)(vmdptr+78);
					stars2pixIndex++; stars2pixIndex++;
					//listaStarsMAXIMA[stars2pixIndex]=0; 
					punteroDeLaMuerteStars=0xB700+stars2pixIndex;
					*punteroDeLaMuerteStars=0;
					stars2pixIndex++;
					//listaStarsMAXIMA[stars2pixIndex]=78; 
					punteroDeLaMuerteStars=0xB700+stars2pixIndex;
					*punteroDeLaMuerteStars=78;
					
					stars2pixIndex++;
					if(stars2pixIndex==MAX_STARS_PIX_MUL)
					{
						stars2pixIndex=0;
					}
				}
			}
			//punteroDeLaMuerteStars=(&listaStarsMAXIMA[MAX_STARS_PIX_MUL-1]);
			punteroDeLaMuerteStars=0xB700+MAX_STARS_PIX_MUL-1;
			if(starsMoment==0)
			{
				scroleaStars();   
				starsMoment=1;
			}else{
				scroleaStarsBis();
				starsMoment=0;
			}
			
			
			//MIRAMOS LOS OPT
			if(acumDespSceneOpt>0)
			{
				acumDespSceneOpt--;
				reorderObjectsUltra();
			}else{
				while(acumDespSceneOpt==0)
				{

					procesaOptCode();
					
					acumDespSceneOpt=sceneOptActual[actualSceneOptPointer++];
				}
				
				acumDespSceneOpt--;
			}
		}
		
		if(addEnemyFromScript1>0)
		{
			save1=sceneOptActual[actualSceneOptPointer];
			save2=sceneOptActual[actualSceneOptPointer+1];
			pointerToByte=&sceneOptActual[actualSceneOptPointer];
			*pointerToByte=addEnemyFromScript1;
			pointerToByte++;
			*pointerToByte=addEnemyFromScript2;
			
			procesaOptCode();
			
			actualSceneOptPointer--;
			actualSceneOptPointer--;
			pointerToByte=&sceneOptActual[actualSceneOptPointer];
			*pointerToByte=save1;
			pointerToByte++;
			*pointerToByte=save2;
			addEnemyFromScript1=0;
			addEnemyFromScript2=0;
		}
		
		
		//reorderObjectsFast();
		reorderObjectsUltra();
		moverLogicaJuegoCheckCollision();
	}else if(moment==4){
		//-----------------------------------------------------------------------------
		//---MOVEMOS SCROLL FOREGROUND DEL ESCENARIO (y ya esta, no da tiempo a mas)---
		//-----------------------------------------------------------------------------
		//cpct_setBorder(HW_BRIGHT_RED);
		if(stopSceneTime==0)
		{
			// scroll por tiles, octoScroll
			contadorScroll=150;
			//punteroDeLaMuerte=(&listaSceneMAXIMA[MAX_SCENE_PIX_MUL-1]);
			punteroDeLaMuerte=0xB800 + MAX_SCENE_PIX_MUL - 1;
			octoScroll();
		}else{
			reorderObjectsUltra();
		}
	}else if(moment==6){
		
		//----------------------------------------------------------------------
		//---AJUSTAMOS COLISIONES DEL ESCENARIO Y AJUSTAMOS LOS TILES-----------
		//---Y TAMBIEN COMPROBAMOS COLISIONES ENTRE OBJETOS---------------------
		//----------------------------------------------------------------------
		//cpct_setBorder(HW_BRIGHT_MAGENTA); 

		if(stopSceneTime==0)
		{
			punteroDeLaMuerte=0xB400;
			//cpct_memcpy(&sceneCollision[0], &sceneCollision[8], 632);
			cpct_memcpy(punteroDeLaMuerte, punteroDeLaMuerte+8, 632);
			//sceneCollision[639]=0;
			punteroDeLaMuerte=0xB400+639;
			*punteroDeLaMuerte=0;
			//sceneCollision[638]=0;
			punteroDeLaMuerte--;
			*punteroDeLaMuerte=0;
			//sceneCollision[637]=0;
			punteroDeLaMuerte--;
			*punteroDeLaMuerte=0;
			//sceneCollision[636]=0;
			punteroDeLaMuerte--;
			*punteroDeLaMuerte=0;
			//sceneCollision[635]=0;
			punteroDeLaMuerte--;
			*punteroDeLaMuerte=0;
			//sceneCollision[634]=0;
			punteroDeLaMuerte--;
			*punteroDeLaMuerte=0;
			//sceneCollision[633]=0;
			punteroDeLaMuerte--;
			*punteroDeLaMuerte=0;
			//sceneCollision[632]=0;
			punteroDeLaMuerte--;
			*punteroDeLaMuerte=0;
			
			//MEJORADA
			punteroDeLaMuerte=0xB400;
			aux=24;
			while(aux>0)
			{
				aux--;
				if(listaPrepareCollisions[aux])
				{
					colisionIndex=5056+(aux*2);
					//cpct_setBit(sceneCollision,  1, colisionIndex++);
					cpct_setBit(punteroDeLaMuerte,  1, colisionIndex++);
					//cpct_setBit(sceneCollision,  1, colisionIndex);
					cpct_setBit(punteroDeLaMuerte,  1, colisionIndex);
				}
			}
		}
		
		//cpct_setBorder(HW_PASTEL_CYAN);
		reorderObjectsUltra();
		moverLogicaJuegoCheckCollision();
	}
}





void insertObject(u8 type, u8 x, u8 y, u8 w, u8 h, void (*stepfunc)(u8),void (*colifunc)(u8,u8) ,u8 aux1, u8 aux2, u8 aux3, i8 aux4, i8 aux5)
{
	index=findFreeGameObject(); 
	if(index)
	{
		gobjToInsert.type=type;
		gobjToInsert.x=x;
		gobjToInsert.y=y;
		gobjToInsert.w=w;
		gobjToInsert.h=h;
		vmdy=gobjToInsert.y; getvmd();
		gobjToInsert.bytePtr=vmdptr+gobjToInsert.x;
		gobjToInsert.ptrStepFunc=stepfunc;
		gobjToInsert.ptrColisionFunc=colifunc;
		gobjToInsert.aux1=aux1;
		gobjToInsert.aux2=aux2;
		gobjToInsert.aux3=aux3;
		gobjToInsert.aux4=aux4;
		gobjToInsert.aux5=aux5;
		cpct_memcpy(&listaObjetos[index],&gobjToInsert,16);
		
		if(index>10)
		{
			stopSceneTime=8;
		}
	}
}


void procesaOptCode()
{
	u8 r;
	u8 aux;
	
	//leemos el tipo
	aux=sceneOptActual[actualSceneOptPointer++];

	if(aux==0)
	{
		//do nothing
		
	}
	if(aux>90 && aux<111)
	{
		//1-40 enems
		//index=findFreeGameObject(); 
		//if(index)
		//{
			if(aux==100)
			{
				//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
				insertObject(aux, 76, sceneOptActual[actualSceneOptPointer++], 4, 16, 
					controllerENEM1,collisionENEM1 ,60,0,0,0,2);
				
			}else if(aux==101){
				//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
				insertObject(aux, 76, sceneOptActual[actualSceneOptPointer++], 4,16, 
					controllerENEM4,collisionENEM4 ,0,0,0,(cpct_getRandom_lcg_u8(0)%3)-1,(cpct_getRandom_lcg_u8(0)%8)+2);
				
				
			//aki entre medio va el cruiser toxal
				
			}else if(aux==102){
				//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
				insertObject(aux, 76, sceneOptActual[actualSceneOptPointer++], 4,16, 
					controllerENEM6,collisionENEM6 ,0,0,5,3,0);
				
			}else if(aux==91){
				//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
				insertObject(aux, 76, sceneOptActual[actualSceneOptPointer++], 4,16, 
					controllerENEM7,collisionENEM7 ,0,0,0,16,(cpct_getRandom_lcg_u8(0)%128)-64);
				
			}
		//}
	}
	if(aux>110 && aux<121)
	{
		//index=findFreeGameObject();
		//if(index)
		//{
			if(aux==111)
			{
				//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
				insertObject(aux, 76, sceneOptActual[actualSceneOptPointer++], 4,16, 
					controllerENEM2,collisionENEM2 ,1,cpct_getRandom_lcg_u8(0)%20,0,0,3);
				
				
				
			}else if(aux==112){
				//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
				insertObject(aux, 76, sceneOptActual[actualSceneOptPointer++], 4,16, 
					controllerENEM3,collisionENEM3 ,5,0,0,-5,6);
				//actualSceneOptPointer++; //aluckardo quita esto y pon lo de arriba
				
			
				
				
			}
		//}
	}
	if(aux>119 && aux<221)
	{
		if(aux==120)
		{
			//index=findFreeGameObject();
			//if(index)
			//{
				//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
				actualSceneOptPointer++;
				insertObject(aux, 60, 140, GRA_BOSS1_W,GRA_BOSS1_H, 
					controllerBOSS1,collisionBOSS1 ,1,3,32,120,LIFE_BOSS1);
				
			//}
		}else if(aux==121){
			//index=findFreeGameObject();
			//if(index)
			//{
				//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
				actualSceneOptPointer++;
				insertObject(aux, 2, 8, GRA_BOSS2A_W,GRA_BOSS2A_H, 
					controllerBOSS2,collisionBOSS2 ,0,cpct_getRandom_lcg_u8(0)%20,0,0,LIFE_BOSS2);
				
				
				
				insertObject(aux, 74, 8, GRA_BOSS2A_W,GRA_BOSS2A_H, 
					controllerBOSS2,collisionBOSS2 ,1,cpct_getRandom_lcg_u8(0)%20,0,0,LIFE_BOSS2);
					
				insertObject(aux, 74, 168, GRA_BOSS2A_W,GRA_BOSS2A_H, 
					controllerBOSS2,collisionBOSS2 ,2,cpct_getRandom_lcg_u8(0)%20,0,0,LIFE_BOSS2);
				
				insertObject(aux, 2, 168, GRA_BOSS2A_W,GRA_BOSS2A_H, 
					controllerBOSS2,collisionBOSS2 ,3,cpct_getRandom_lcg_u8(0)%20,0,0,LIFE_BOSS2);
				
				
			//}
		}else if(aux==122){			
			//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
			actualSceneOptPointer++;
			insertObject(aux, 64, 148, GRA_CHICAGO30_W,GRA_CHICAGO30_H, 
				controllerBOSS3,collisionBOSS3 ,LIFE_BOSS3,(cpct_getRandom_lcg_u8(0)%32)+1,0,(cpct_getRandom_lcg_u8(0)%64)+1,0);
		}
		
	}
	if(aux==230)
	{
		r=sceneOptActual[actualSceneOptPointer++]; 
		
		
		//TO DEBUG creamos una explosion simplemente para debugear (YA ESTA PROBADO, NO HACE FALTA)
		index=findFreeGameObject();
		if(index)
		{
			insertObject(aux, 76, 0, 1,1, 
				controllerScript,0 ,0,0,0,0,0);
			if(r==1)
			{	
				listaObjetos[index].bytePtr=script1pruebas;
			}else if(r==2){
				listaObjetos[index].bytePtr=scriptStopScroll;
			}else if(r==11){
				listaObjetos[index].bytePtr=scriptL1setPalete;
			}else if(r==21){
				listaObjetos[index].bytePtr=scriptL2setPalete;
			}else if(r==31){
				listaObjetos[index].bytePtr=scriptL3setPalete;
			}else if(r==100){
				listaObjetos[index].bytePtr=scriptMasiveAttackNaves;
			}else if(r==101){
				listaObjetos[index].bytePtr=scriptMasiveAttackMeteor; 
			}else if(r==102){
				listaObjetos[index].bytePtr=scriptMasiveAttackWormHole;
			}
			
		}
		
	}
	if(aux==255)
	{
		//255 end level //hacemos bucle para que se kede en el boss
		actualSceneOptPointer--; 
		actualSceneOptPointer--;
	}
}





u8 findFreeGameObject()
{
	for(u8 i=1; i<MAXOBJECTS; i++)
	{
		if(!listaObjetos[i].type)
		{
			return i;
		}
	}
	return 0; //false
}






u8 findProtaIndex()
{
	for(u8 i=0; i<MAXOBJECTS; i++)
	{
		if(listaObjetos[i].type==1)
		{
			return i;
		}
	}
	return 255;
}

//recorremos todos los objetos que sean enemigos y nos quedamos con el que este más cerca en el eje x
u8 findEnemyIndex(u8 px)
{
	u8 dist;
	u8 ir;
	ir=255;
	dist=255;
	for(u8 i=0; i<MAXOBJECTS; i++)
	{
		if(listaObjetos[i].type>99 && listaObjetos[i].type<140)
		{
			if(px>listaObjetos[i].x)
			{
				if(dist>(px-listaObjetos[i].x))
				{
					ir=i;
					dist=px-listaObjetos[i].x;
				}
			}else{
				if(dist>(listaObjetos[i].x-px))
				{
					ir=i;
					dist=listaObjetos[i].x-px;
				}
			}
		}
	}
	return ir;
}





void controllerNaveProta(u8 o1)
{
	u8 aux;
	
	//cpct_setBorder(HW_BLUE);
	
	cpct_scanKeyboard();
	
	if(cpct_isKeyPressed(keyToLeft) && listaObjetos[o1].x>2)
	{
		vmdy=listaObjetos[o1].y; getvmd();
		cpct_drawSolidBox(vmdptr+listaObjetos[o1].x+6, 0, 1, 10);
		listaObjetos[o1].x--;  
		listaObjetos[o1].aux4=0;
		redrawNave=1;
		//hay que limpiar por la derecha 
	}else if(cpct_isKeyPressed(keyToRight) && listaObjetos[o1].x<70){
		vmdy=listaObjetos[o1].y; getvmd();
		cpct_drawSolidBox(vmdptr+listaObjetos[o1].x, 0, 1, 10);
		vmdy=listaObjetos[o1].y+3; getvmd();
		cpct_drawSolidBox(vmdptr+listaObjetos[o1].x-2, 0, 1, 6);
		listaObjetos[o1].x++;
		if(listaObjetos[o1].aux4==3)
		{
			listaObjetos[o1].aux4=4;
		}else{
			listaObjetos[o1].aux4=3;
		}
		redrawNave=1;
		//hay que limpiar por la izquierda
	}else{
		if(listaObjetos[o1].aux4==5)
		{
			listaObjetos[o1].aux4=6;
		}else{
			listaObjetos[o1].aux4=5;
		}
	}
	
	if(cpct_isKeyPressed(keyToUp) && listaObjetos[o1].y>3)
	{
		//hay que limpiar por abajo
		vmdy=listaObjetos[o1].y+7; getvmd();
		cpct_drawSolidBox(vmdptr+listaObjetos[o1].x, 0, 7, 4);
		vmdy=listaObjetos[o1].y+6; getvmd();
		cpct_drawSolidBox(vmdptr+listaObjetos[o1].x-2, 0, 2, 3);
		listaObjetos[o1].y=listaObjetos[o1].y-3;
		listaObjetos[o1].aux5=1;
		redrawNave=1;
	}else if(cpct_isKeyPressed(keyToDown) && listaObjetos[o1].y<178){
		//hay que limpiar por arriba e ir moviendo la y
		vmdy=listaObjetos[o1].y; getvmd();
		cpct_drawSolidBox(vmdptr+listaObjetos[o1].x, 0, 7, 3);
		vmdy=listaObjetos[o1].y+3; getvmd();
		cpct_drawSolidBox(vmdptr+listaObjetos[o1].x-2, 0, 2, 3);
		listaObjetos[o1].y=listaObjetos[o1].y+3;
		listaObjetos[o1].aux5=2;
		redrawNave=1;
	}else{
		listaObjetos[o1].aux5=0;
	}
	
	
	
	//release shot time
	if(listaObjetos[o1].aux1==0)
	{
		if(cpct_isKeyPressed(keyToFire))
		{
			if(weaponLevel==0)
			{
				//LASER BEAM
				if(cpct_akp_SFXGetInstrument(4)==0)
				{
					cpct_akp_SFXPlay(4, 15, 52,0, 0, 4);
				}
				insertObject(2, listaObjetos[o1].x+6, listaObjetos[o1].y+6, 2, 1, controllerShootProta,0 ,0,0,0,0,0);
				listaObjetos[o1].aux1=5; //ralentizar el siguiente disparo
			}else if(weaponLevel==3){
				//DOUBLE LASER
				if(cpct_akp_SFXGetInstrument(4)==0)
				{
					cpct_akp_SFXPlay(4, 15, 52,0, 0, 4);
				}
				insertObject(2, listaObjetos[o1].x+6, listaObjetos[o1].y+9, 2, 1, controllerShootProta,0 ,0,0,0,-1,0);
				insertObject(2, listaObjetos[o1].x+6, listaObjetos[o1].y+3, 2, 1, controllerShootProta,0 ,0,0,0,1,0);
				listaObjetos[o1].aux1=8; //ralentizar el siguiente disparo
			}else if(weaponLevel==2){
				//PLASMA BALL
				if(cpct_akp_SFXGetInstrument(4)==0)
				{
					cpct_akp_SFXPlay(9, 15, 52,0, 0, 4);
				}
				insertObject(3, listaObjetos[o1].x+6, listaObjetos[o1].y, 4, 16, controllerShootProtaPlasma,0 ,0,0,0,0,0);
				listaObjetos[o1].aux1=15; //ralentizar el siguiente disparo
			}else if(weaponLevel==5){
				//DOUBLE PLASMA BALL
				if(cpct_akp_SFXGetInstrument(4)==0)
				{
					cpct_akp_SFXPlay(9, 15, 52,0, 0, 4);
				}
				insertObject(3, listaObjetos[o1].x+6, listaObjetos[o1].y-3, 4, 16, controllerShootProtaPlasma,0 ,0,0,0,1,0);
				insertObject(3, listaObjetos[o1].x+6, listaObjetos[o1].y+3, 4, 16, controllerShootProtaPlasma,0 ,0,0,0,-1,0);
				listaObjetos[o1].aux1=20; //ralentizar el siguiente disparo
			}else if(weaponLevel==1){
				//HOMMING MISILE
				if(cpct_akp_SFXGetInstrument(4)==0)
				{
					cpct_akp_SFXPlay(4, 15, 52,0, 0, 4);
				}
				insertObject(5, listaObjetos[o1].x+6, listaObjetos[o1].y, 3, 8, controllerShootProtaRocket,0 ,0,listaObjetos[o1].y,0,3,0);
				listaObjetos[o1].aux1=20;
			}else if(weaponLevel==4){
				//DOBLE HOMMING MISILE
				if(cpct_akp_SFXGetInstrument(4)==0)
				{
					cpct_akp_SFXPlay(4, 15, 52,0, 0, 4);
				}
				insertObject(5, listaObjetos[o1].x+6, listaObjetos[o1].y+4, 3, 8, controllerShootProtaRocket,0 ,0,listaObjetos[o1].y+4,0,3,0);
				insertObject(5, listaObjetos[o1].x+6, listaObjetos[o1].y-4, 3, 8, controllerShootProtaRocket,0 ,0,listaObjetos[o1].y-4,0,3,0);
				listaObjetos[o1].aux1=30;
			}
		}
	}else{
		listaObjetos[o1].aux1--; 
	}
	
	
	if(redrawNave)
	{
		vmdy=listaObjetos[o1].y; getvmd();
		listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
		cpct_drawSprite(listaSpriteProta[listaObjetos[o1].aux5], listaObjetos[o1].bytePtr, GRA_NAVEE_W, GRA_NAVEE_H); 
	}
	
	if(listaObjetos[o1].aux4)
	{
		vmdy=listaObjetos[o1].y+3; getvmd();
		listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
		cpct_drawSprite(listaSpriteProta[listaObjetos[o1].aux4], listaObjetos[o1].bytePtr-2, GRA_ENGINEA_W, GRA_ENGINEA_H); 
	}
	
	//nueva colision 
	colisionIndex=((listaObjetos[o1].x+2)*64)+(listaObjetos[o1].y/4);
	for(aux=3; aux--;)
	{
		punteroDeLaMuerte=0xB400;
		//if(cpct_getBit(sceneCollision, colisionIndex))
		if(cpct_getBit(punteroDeLaMuerte, colisionIndex))
		{
			pierdeVida(o1);
			break;
		}
		colisionIndex=colisionIndex+1;
		//if(cpct_getBit(sceneCollision, colisionIndex))
		if(cpct_getBit(punteroDeLaMuerte, colisionIndex))
		{
			pierdeVida(o1);
			break;
		}
		//colisionIndex=colisionIndex+63;
		colisionIndex=colisionIndex+127;
	}
	
	if(cpct_isKeyPressed(Key_N))
	{
		timeToNextLevel=100;
	}
	
	
	//cpct_setBorder(HW_BLACK);
}


void collisionNaveProta(u8 o1,u8 o2)
{
	if(listaObjetos[o2].type>99)
	{
		pierdeVida(o1);
	}
}


void pierdeVida(u8 o1)
{
	//if(KILL_ON_HIT)
	//{
		u8 o2=findFreeGameObject();
		if(o2)
		{
			//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
			gobjToInsert.type=50;
			gobjToInsert.x=listaObjetos[o1].x;
			gobjToInsert.y=listaObjetos[o1].y;
			gobjToInsert.w=4;
			gobjToInsert.h=16;
			vmdy=gobjToInsert.y; getvmd();
			gobjToInsert.bytePtr=vmdptr+gobjToInsert.x;
			gobjToInsert.ptrStepFunc=controllerEXPLO1;
			gobjToInsert.ptrColisionFunc=0;
			gobjToInsert.aux1=10;
			gobjToInsert.aux2=0;
			gobjToInsert.aux3=1;
			gobjToInsert.aux4=0;
			gobjToInsert.aux5=0;
			cpct_memcpy(&listaObjetos[o2],&gobjToInsert,16);
			
			
			shakeTime=5;
		
			o2=findFreeGameObject();
			if(o2)
			{
				//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
				gobjToInsert.x=gobjToInsert.x+4;
				gobjToInsert.bytePtr=vmdptr+gobjToInsert.x;
				cpct_memcpy(&listaObjetos[o2],&gobjToInsert,16);
				
			}
			cleanKilledObject(o1);
			if(cpct_akp_SFXGetInstrument(4)==0)
			{
				cpct_akp_SFXPlay(4, 15, 52,0, 0, 4);
			}
			
			lives=lives-PIERDE_VIDAS;              // Y SE REINICIA EL NIVEL O NOS LLEVA AL GAME OVER
		}
	//}
}

void controllerShootProta(u8 o1)
{
	//borra dos bytes, pinta los 2 siguientes, y avanza el disparo 2 bytes
	pointerToByte=listaObjetos[o1].bytePtr;
	
	*pointerToByte=0;pointerToByte++; 
	*pointerToByte=0;
	
	colisionIndex=((listaObjetos[o1].x+3)*64)+(listaObjetos[o1].y/4);
	
	//ojo, el 79 no lo pintes que si no provoca que lo considere como colision
	punteroDeLaMuerte=0xB400;
	//if(listaObjetos[o1].x<76 && cpct_getBit(sceneCollision, colisionIndex)==0)
	if(listaObjetos[o1].x<76 && cpct_getBit(punteroDeLaMuerte, colisionIndex)==0)
	{
		listaObjetos[o1].x++;
		listaObjetos[o1].x++;
		
		if(listaObjetos[o1].aux4!=0)
		{
			listaObjetos[o1].y=listaObjetos[o1].y+listaObjetos[o1].aux4;
			if(listaObjetos[o1].y>192)
			{
				listaObjetos[o1].y=listaObjetos[o1].y-listaObjetos[o1].aux4;
			}
			vmdy=listaObjetos[o1].y; getvmd();
			pointerToByte=vmdptr+listaObjetos[o1].x;			
		}else{
			pointerToByte++;
		}
		
		listaObjetos[o1].bytePtr=pointerToByte;
		*pointerToByte=255;pointerToByte++;
		*pointerToByte=255;pointerToByte++;
	}else{
		listaObjetos[o1].type=0; //desactivamos el objeto
	}
}



void controllerShootProtaPlasma(u8 o1)
{
	//limpia la parte de atras y arriba y abajo por si sube o baja
	colisionIndex=((listaObjetos[o1].x+3)*64)+((listaObjetos[o1].y+4)/4);
	punteroDeLaMuerte=0xB400;
	//if(cpct_getBit(sceneCollision, colisionIndex)==0)
	if(cpct_getBit(punteroDeLaMuerte, colisionIndex)==0)
	{
		if(listaObjetos[o1].x<75)
		{
			
			if(listaObjetos[o1].aux4!=0)
			{
				//borra el borde de arriba y el de abajo
				listaObjetos[o1].bytePtr++;
				*(listaObjetos[o1].bytePtr)=0;
				listaObjetos[o1].bytePtr++;
				*(listaObjetos[o1].bytePtr)=0;
				vmdy=listaObjetos[o1].y+7; getvmd();
				pointerToByte=vmdptr+listaObjetos[o1].x;
				pointerToByte++;
				*pointerToByte=0;
				pointerToByte++;
				*pointerToByte=0;
				
				listaObjetos[o1].y=listaObjetos[o1].y+listaObjetos[o1].aux4;	
				if(listaObjetos[o1].y>180)
				{
					listaObjetos[o1].y=listaObjetos[o1].y-listaObjetos[o1].aux4; //VOLVEMOS PATRAS
				}
			}

			
			listaObjetos[o1].x++;
	
			vmdy=listaObjetos[o1].y; getvmd();
			listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;	

			pointerToByte=listaObjetos[o1].bytePtr;
			drawSprite16Puntero=gra_plasmaA;
			drawSprite16y=listaObjetos[o1].y;
			drawSprite12x8();
			
		}else{
			cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, 3, 8);
			listaObjetos[o1].type=0; //desactivamos el objeto
		}
	}else{
		cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, 3, 8);
		listaObjetos[o1].type=0; //desactivamos el objeto
	}
	
}





void dividePlasma(u8 o1)
{
	//aqui hay que dividir el plasma grande en 3 pekeñitos
	u8 o3=findFreeGameObject();
	if(o3)
	{
		//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
		gobjToInsert.type=4;
		gobjToInsert.x=listaObjetos[o1].x+6;
		gobjToInsert.y=listaObjetos[o1].y+6;
		gobjToInsert.w=2;
		gobjToInsert.h=4;
		vmdy=gobjToInsert.y; getvmd();
		gobjToInsert.bytePtr=vmdptr+gobjToInsert.x;
		gobjToInsert.ptrStepFunc=controllerShootProtaPlasmaMini;
		gobjToInsert.ptrColisionFunc=0;
		gobjToInsert.aux1=0;
		gobjToInsert.aux2=0;
		gobjToInsert.aux3=0;
		gobjToInsert.aux4=(cpct_getRandom_lcg_u8(0)%9)-4;
		gobjToInsert.aux5=(cpct_getRandom_lcg_u8(0)%9)-4;
		cpct_memcpy(&listaObjetos[o3],&gobjToInsert,16);
	}
	
	o3=findFreeGameObject();
	if(o3)
	{
		//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
		gobjToInsert.aux4=(cpct_getRandom_lcg_u8(0)%9)-4;
		gobjToInsert.aux5=(cpct_getRandom_lcg_u8(0)%9)-4;
		cpct_memcpy(&listaObjetos[o3],&gobjToInsert,16);
	}
}


//en principio copiamos el mismo funcionamiento que el shot de los enemigos
void controllerShootProtaPlasmaMini(u8 o1)
{
	//limpiamos
	cpct_drawSolidBox(listaObjetos[o1].bytePtr,0,GRA_SHOT1A_W,GRA_SHOT1A_H);
	
	//movemos
	//aux1 --> es el desplazamiento si es mayor que 3 x=x+1; si es mayor que 250 x=x-1;
	//aux4 --> velocidad de x en cada frame (es i8 por lo tanto positivo o negativo)
	//aux5 --> velocidad de y en cada frame (es i8 por lo tanto positivo o negativo)
	
	listaObjetos[o1].aux1=listaObjetos[o1].aux1+listaObjetos[o1].aux4; //hacemos casting a s8 para poder usar negativos
	listaObjetos[o1].y=listaObjetos[o1].y + listaObjetos[o1].aux5;

	//ajustamos
	if(listaObjetos[o1].aux1>250)
	{
		listaObjetos[o1].aux1=listaObjetos[o1].aux1+4;
		listaObjetos[o1].x--;
	}else if(listaObjetos[o1].aux1>3){
		listaObjetos[o1].aux1=listaObjetos[o1].aux1-4;
		listaObjetos[o1].x++;
	}
	
	vmdy=listaObjetos[o1].y; getvmd();
	listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
	
	
	//check limits
	punteroDeLaMuerte=0xB400;
	colisionIndex=(listaObjetos[o1].x*64)+(listaObjetos[o1].y/4);
	//if(cpct_getBit(sceneCollision, colisionIndex))
	if(cpct_getBit(punteroDeLaMuerte, colisionIndex))
	{
		listaObjetos[o1].type=0; //liberamos
	}else if(listaObjetos[o1].y>186 || listaObjetos[o1].x>76){
		listaObjetos[o1].type=0; //liberamos
	}else{
		//dibujamos
		vmdy=listaObjetos[o1].y; getvmd();
		listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
		//cpct_drawSprite(listaSpriteShot2[listaObjetos[o1].aux1], listaObjetos[o1].bytePtr, GRA_SHOT2A_W, GRA_SHOT2A_H);
		pointerToByte=listaObjetos[o1].bytePtr;
		drawSprite16Puntero=listaSpriteShot2[listaObjetos[o1].aux1];
		drawSprite16y=listaObjetos[o1].y;
		drawSprite8x4();
	}
}

//OJO, esta funcion se va a reutilizar tanto para los cohetes malos como para los wenos
//para saber si es malo o no... paux3=0 es bueno, paux3=10 es malo
void controllerShootProtaRocket(u8 o1)
{
	//movemos
	//aux1 --> es el desplazamiento si es mayor que 3 x=x+1; si es mayor que 250 x=x-1;
	//aux2  --> es la y antigua de la ultima vez que pintamos
	//aux3 --> cada cuantos frames vamos a comprobar la IA del rocket
	//aux4 --> velocidad de x en cada frame (es i8 por lo tanto positivo o negativo)
	//aux5 --> velocidad de y en cada frame (es i8 por lo tanto positivo o negativo)
	u8 goTarget;


	//IA del rocket  
	goTarget=255;
	listaObjetos[o1].aux3++;
	if(listaObjetos[o1].aux3==6)
	{
		listaObjetos[o1].aux3=0;
		goTarget=findEnemyIndex(listaObjetos[o1].x);
	}
	
	if(listaObjetos[o1].aux3==16)
	{
		listaObjetos[o1].aux3=10;
		goTarget=findProtaIndex();
	}
	
	
	if(listaObjetos[o1].aux3%2==0)
	{
		//limpiamos
		//vmdy=listaObjetos[o1].aux2; getvmd();
		//cpct_drawSolidBox(listaObjetos[o1].bytePtr,0,GRA_ROCKET0A_W,GRA_ROCKET0A_H);
		pointerToByte=listaObjetos[o1].bytePtr;
		drawSprite16Puntero=gra_black16a16;  //aunque es mas grande no pasa nada porque es todo negro y va a parar antes de que se acabe, no problem
		drawSprite16y=listaObjetos[o1].aux2;
		drawSprite12x8();
	}
	
	
	if(goTarget<MAXOBJECTS)
	{
		//vamos a por este
		if(listaObjetos[o1].aux4<((listaObjetos[goTarget].x-listaObjetos[o1].x)/2))
		{
			listaObjetos[o1].aux4++;
			if(listaObjetos[o1].aux4>4)
			{
				listaObjetos[o1].aux4=4;
			}
		}else{
			listaObjetos[o1].aux4--;
			if(listaObjetos[o1].aux4< (-4))
			{
				listaObjetos[o1].aux4=-4;
			}
		}
		
		//vamos a por este
		if(listaObjetos[o1].aux5<((listaObjetos[goTarget].y-listaObjetos[o1].y)/2))
		{
			listaObjetos[o1].aux5++;
			if(listaObjetos[o1].aux5>4)
			{
				listaObjetos[o1].aux5=4;
			}
		}else{
			listaObjetos[o1].aux5--;
			if(listaObjetos[o1].aux5< (-4))
			{
				listaObjetos[o1].aux5=-4;
			}
		}
	}
	
	listaObjetos[o1].aux1=listaObjetos[o1].aux1+listaObjetos[o1].aux4; 
	listaObjetos[o1].y=listaObjetos[o1].y + listaObjetos[o1].aux5;

	//ajustamos	
	if(listaObjetos[o1].aux1>250)
	{
		listaObjetos[o1].aux1=listaObjetos[o1].aux1+4;
		listaObjetos[o1].x--;
		if(listaObjetos[o1].aux1>250)
		{
			listaObjetos[o1].aux1=listaObjetos[o1].aux1+4;
			listaObjetos[o1].x--;
		}
	}else{
		if(listaObjetos[o1].aux1>3)
		{
			listaObjetos[o1].aux1=listaObjetos[o1].aux1-4;
			listaObjetos[o1].x++;
			if(listaObjetos[o1].aux1>3)
			{
				listaObjetos[o1].aux1=listaObjetos[o1].aux1-4;
				listaObjetos[o1].x++;
			}
		}
	}
	
	
	
	
	
	
	//check limits
	punteroDeLaMuerte=0xB400;
	colisionIndex=(listaObjetos[o1].x*64)+(listaObjetos[o1].y/4);
	if(listaObjetos[o1].y>176 || listaObjetos[o1].x>76 || cpct_getBit(punteroDeLaMuerte, colisionIndex))
	{
		listaObjetos[o1].type=0; //liberamos
		
		//limpiamos
		pointerToByte=listaObjetos[o1].bytePtr;
		drawSprite16Puntero=gra_black16a16;  //aunque es mas grande no pasa nada porque es todo negro y va a parar antes de que se acabe, no problem
		drawSprite16y=listaObjetos[o1].aux2;
		drawSprite12x8();

	}else{
		if(listaObjetos[o1].aux3%2==0)
		{
			vmdy=listaObjetos[o1].y; getvmd();
			listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
			pointerToByte=listaObjetos[o1].bytePtr;
			if(listaObjetos[o1].aux4<0)
			{
				if(listaObjetos[o1].aux5<0)
				{
					if(listaObjetos[o1].aux4<listaObjetos[o1].aux5)
					{
						drawSprite16Puntero=listaSpriteRocket[8+listaObjetos[o1].aux1];
					}else{
						drawSprite16Puntero=listaSpriteRocket[4+listaObjetos[o1].aux1];
					}
				}else{
					if((listaObjetos[o1].aux4*-1)>listaObjetos[o1].aux5)
					{
						drawSprite16Puntero=listaSpriteRocket[8+listaObjetos[o1].aux1];
					}else{
						drawSprite16Puntero=listaSpriteRocket[12+listaObjetos[o1].aux1];
					}
				}
			}else{
				if(listaObjetos[o1].aux5<0)
				{
					if(listaObjetos[o1].aux4<(listaObjetos[o1].aux5*-1))
					{
						drawSprite16Puntero=listaSpriteRocket[4+listaObjetos[o1].aux1];
					}else{
						drawSprite16Puntero=listaSpriteRocket[listaObjetos[o1].aux1];
					}
				}else{
					if(listaObjetos[o1].aux4>listaObjetos[o1].aux5)
					{
						drawSprite16Puntero=listaSpriteRocket[listaObjetos[o1].aux1];
					}else{
						drawSprite16Puntero=listaSpriteRocket[12+listaObjetos[o1].aux1];
					}
				}
			}
			
			
			drawSprite16y=listaObjetos[o1].y;
			drawSprite12x8();
			listaObjetos[o1].aux2=listaObjetos[o1].y; //nos guardamos el y para luego saber donde tenemos que borrar
		}
	}
	
}


void controllerENEM1(u8 o1)
{
	listaObjetos[o1].aux1--;
	if(listaObjetos[o1].aux1<30)
	{
		listaObjetos[o1].y--;
		if(listaObjetos[o1].aux1==0)
		{
			listaObjetos[o1].aux1=60; 
		}
	}else{
		listaObjetos[o1].y++;
	}

	listaObjetos[o1].x--;
	
	vmdy=listaObjetos[o1].y; getvmd();
	listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
	if(listaObjetos[o1].x==0)
	{
		cleanKilledObject(o1);
	}else{	
		pointerToByte=listaObjetos[o1].bytePtr;
		drawSprite16Puntero=gra_enem1c;
		drawSprite16y=listaObjetos[o1].y;
		drawSprite16();
	}

}


void explodeMe(u8 o1)
{
	u8 oaux;
	oaux=findFreeGameObject();
	
	gobjToInsert.type=50;
	gobjToInsert.x=listaObjetos[o1].x;
	gobjToInsert.y=listaObjetos[o1].y;
	gobjToInsert.w=4;
	gobjToInsert.h=16;
	vmdy=gobjToInsert.y; getvmd();
	gobjToInsert.bytePtr=vmdptr+gobjToInsert.x;
	gobjToInsert.ptrStepFunc=controllerEXPLO1;
	gobjToInsert.ptrColisionFunc=0;
	gobjToInsert.aux1=10;
	gobjToInsert.aux2=0;
	gobjToInsert.aux3=0;
	gobjToInsert.aux4=0;
	gobjToInsert.aux5=0;
			
	cpct_memcpy(&listaObjetos[oaux],&gobjToInsert,16);
	if(cpct_akp_SFXGetInstrument(4)==0)
	{
		cpct_akp_SFXPlay(4, 15, 52,0, 0, 4);
	}
	
	
	listaObjetos[o1].type=0;
}


void collisionENEM1(u8 o1,u8 o2)
{
	if(listaObjetos[o2].type>1 && listaObjetos[o2].type<31)
	{
		shakeTime=2;
	
		listaObjetos[o1].aux5--;
		if(!listaObjetos[o1].aux5)
		{
			checkItemCreate(o1,0,0);
			explodeMe(o1);
			score=score+2;
		}
		cleanKilledObject(o2);
	}
}


void enemyCreateShot(u8 enemigo,i8 offsetX,i8 offsetY)
{
	u8 indice;
	u8 indice2;
	//gameObject* auxObjEnem;
	//gameObject* auxObjProta;
	
	//auxObjEnem=&listaObjetos[enemigo];
	
	//pequena comprobacion para que no dispare alguien que ya este KO
	if(listaObjetos[enemigo].type!=0)
	{
		indice=findFreeGameObject();
		if(indice)
		{
			//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
			gobjToInsert.type=150;
			gobjToInsert.x=listaObjetos[enemigo].x+offsetX;
			if(gobjToInsert.x>70)
			{
				gobjToInsert.x=0;
			}
			gobjToInsert.y=listaObjetos[enemigo].y+offsetY;
			if(gobjToInsert.y>174)
			{
				gobjToInsert.y=0;
			}
			gobjToInsert.w=2;
			gobjToInsert.h=4;
			vmdy=gobjToInsert.y; getvmd();
			gobjToInsert.bytePtr=vmdptr+gobjToInsert.x;
			gobjToInsert.ptrStepFunc=controllerSHOT1;
			gobjToInsert.ptrColisionFunc=0;
			gobjToInsert.aux1=0;
			gobjToInsert.aux2=gobjToInsert.y;
			gobjToInsert.aux3=0;
			gobjToInsert.aux4=(cpct_getRandom_lcg_u8(0)%3)+1;
			gobjToInsert.aux5=(cpct_getRandom_lcg_u8(0)%3)+1;
			
			indice2=findProtaIndex();
			if(indice2<MAXOBJECTS)
			{
				//auxObjProta=&listaObjetos[indice2];
				
				if((listaObjetos[enemigo].x+8)>listaObjetos[indice2].x)
				{
					gobjToInsert.aux4=-gobjToInsert.aux4;
				}
				if((listaObjetos[enemigo].y+8)>listaObjetos[indice2].y)
				{
					gobjToInsert.aux5=-gobjToInsert.aux5;
				}
			}
			//llegados a este punto aux4 y aux5 deberian tener una direccion correcta
			cpct_memcpy(&listaObjetos[indice],&gobjToInsert,16);
			if(cpct_akp_SFXGetInstrument(4)==0)
			{
				cpct_akp_SFXPlay(4, 15, 52,0, 0, 4);
			}
		}
	}
}



void enemyCreateShotRocket(u8 enemigo,i8 offsetX,i8 offsetY)
{
	u8 indice;
	//gameObject* auxObjEnem;
	
	//auxObjEnem=&listaObjetos[enemigo];
	
	//pequena comprobacion para que no dispare alguien que ya este KO
	if(listaObjetos[enemigo].type!=0)
	{
		indice=findFreeGameObject();
		if(indice)
		{
		
			//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
			gobjToInsert.type=151;
			gobjToInsert.x=listaObjetos[enemigo].x+offsetX;
			gobjToInsert.y=listaObjetos[enemigo].y+offsetY;
			gobjToInsert.w=3;
			gobjToInsert.h=8;
			vmdy=gobjToInsert.y; getvmd();
			gobjToInsert.bytePtr=vmdptr+gobjToInsert.x;
			gobjToInsert.ptrStepFunc=controllerShootProtaRocket;
			gobjToInsert.ptrColisionFunc=0;
			gobjToInsert.aux1=0;
			gobjToInsert.aux2=gobjToInsert.y;
			gobjToInsert.aux3=10;
			gobjToInsert.aux4=-3;
			gobjToInsert.aux5=0;
			cpct_memcpy(&listaObjetos[indice],&gobjToInsert,16);
			
			//llegados a este punto aux4 y aux5 deberian tener una direccion correcta
		}
	}
}


void enemyCreateItem(u8 enemigo,i8 offsetX,i8 offsetY)
{
	u8 indice;
	//gameObject* auxObjEnem;
	//gameObject* auxObjProta;
	
	//auxObjEnem=&listaObjetos[enemigo];
	
	//pequena comprobacion para que no dispare alguien que ya este KO
	if(listaObjetos[enemigo].type!=0)
	{
		indice=findFreeGameObject();
		if(indice)
		{
			//u8 type,u8 x,u8 y,u8 w,u8 h,u8* bytePtr,void (*ptrStepFunc)(u8),void (*ptrColisionFunc)(u8,u8),u8 aux1,u8 aux2,u8 aux3,i8 aux4,i8 aux5;
			gobjToInsert.type=80;
			gobjToInsert.x=listaObjetos[enemigo].x+offsetX;
			gobjToInsert.y=listaObjetos[enemigo].y+offsetY;
			gobjToInsert.w=2;
			gobjToInsert.h=4;
			vmdy=gobjToInsert.y; getvmd();
			gobjToInsert.bytePtr=vmdptr+gobjToInsert.x;
			gobjToInsert.ptrStepFunc=controllerITEMS;
			gobjToInsert.ptrColisionFunc=collisionITEMS;
			gobjToInsert.aux1=0;
			gobjToInsert.aux2=0;
			gobjToInsert.aux3=0;
			gobjToInsert.aux4=(cpct_getRandom_lcg_u8(0)%2)+1;
			gobjToInsert.aux5=(cpct_getRandom_lcg_u8(0)%2)+1;
			
			index2=findProtaIndex();
			if(index2<MAXOBJECTS)
			{
				//auxObjProta=&listaObjetos[index2];
				
				if((listaObjetos[enemigo].x+8)>listaObjetos[index2].x)
				{
					gobjToInsert.aux4=-gobjToInsert.aux4;
				}
				if((listaObjetos[enemigo].y+8)>listaObjetos[index2].y)
				{
					gobjToInsert.aux5=-gobjToInsert.aux5;
				}
			}
			cpct_memcpy(&listaObjetos[indice],&gobjToInsert,16);

			//llegados a este punto aux4 y aux5 deberian tener una direccion correcta
		}
	}
}

//esta funcion mira si se tiene que crear un item o no hace falta
void checkItemCreate(u8 enemigo,i8 offsetX,i8 offsetY)
{
	u8 r=cpct_getRandom_lcg_u8(0);
	if(r<32)
	{
		enemyCreateItem(enemigo,offsetX,offsetY);
	}
}


void controllerENEM2(u8 o1)
{
	if(!stopSceneTime)
	{
		listaObjetos[o1].aux1--;
	}
	listaObjetos[o1].aux2--;
	
	if(listaObjetos[o1].aux2==0)
	{
		//disparamos argo
		listaObjetos[o1].aux2=cpct_getRandom_lcg_u8(0)/3; 
		enemyCreateShot(o1,0,-4);
	}
	
	if(!listaObjetos[o1].aux1)
	{
		cpct_drawSolidBox(listaObjetos[o1].bytePtr+3, 0, 1, 16);
		listaObjetos[o1].aux1=4;
		listaObjetos[o1].x--;
		vmdy=listaObjetos[o1].y; getvmd();
		listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
		if(listaObjetos[o1].x==0)
		{
			cleanKilledObject(o1);
		}else{
			pointerToByte=listaObjetos[o1].bytePtr;
			drawSprite16Puntero=gra_enem2;
			drawSprite16y=listaObjetos[o1].y;
			drawSprite16();
		}
	}
}

void collisionENEM2(u8 o1,u8 o2)
{
	if(listaObjetos[o2].type>1 && listaObjetos[o2].type<31)
	{
		cleanKilledObject(o2);
		shakeTime=2;
		listaObjetos[o1].aux5--;
		if(!listaObjetos[o1].aux5)
		{
			checkItemCreate(o1,0,0);
			score=score+5;
			explodeMe(o1);
		}
	}
}


//jumper, va saltando todo el rato en su eje x, y cuando esta arriba del todo suelta mierda
void controllerENEM3(u8 o1)
{
	
	//aux4 velocidad vertical
	//aux1 cuando es cero movemos a la izquierda (con el scroll)
	//IA JUMPER
	
	//cpct_setBorder(HW_GREEN);
	
	//elimino mi sprite actual
	
	//ESTO SOLO PUEDE PETAR SI bytePtr ESTA APUNTANDO A CUENCA
	pointerToByte=listaObjetos[o1].bytePtr; //esto es pa limpiar igual que el drawSolidBox
	drawSprite16Puntero=gra_black16a16;
	drawSprite16y=listaObjetos[o1].y;
	drawSprite16();
	
	//muevo mi ejeY en funcion de aux4
	//ESTO NO PUEDE PETAR PERO PUEDE DEJAR Y FUERA DE LUGAR
	listaObjetos[o1].y=listaObjetos[o1].y+listaObjetos[o1].aux4;
	//esto es por si se sale por arriba
	
	//EN CASO DE DEJARLO FUERA DE LUGAR ESTO LO AJUSTARIA DENTRO DE LA PANTALLA DE NUEVO
	if(listaObjetos[o1].y>174)
	{
		listaObjetos[o1].y=0;
		listaObjetos[o1].aux4=-1;
	}
	
	//movimiento ejex
	//ESTO NO PUEDE FALLAR
	listaObjetos[o1].aux1--;
	if(listaObjetos[o1].aux1==0){
		listaObjetos[o1].x--;
		listaObjetos[o1].aux1=2;
	}
	
	//si tengo suelo abajo...
	punteroDeLaMuerte=0xB400;
	colisionIndex=(listaObjetos[o1].x*64)+((listaObjetos[o1].y/4)+4);
	if(cpct_getBit(punteroDeLaMuerte, colisionIndex))
	{
		//subo un poco para no borrar escenario
		listaObjetos[o1].y=listaObjetos[o1].y-listaObjetos[o1].aux4;
		if(listaObjetos[o1].y>174)
		{
			listaObjetos[o1].y=0;
		}
		//salto aux4=random(8) * -1
		listaObjetos[o1].aux4=((cpct_getRandom_lcg_u8(0)%6)+4)*-1;
	//sino
	}else{
		if(listaObjetos[o1].aux2==0)
		{
			listaObjetos[o1].aux2=1;
		}else{
			listaObjetos[o1].aux2=0;
			listaObjetos[o1].aux4++;
			/*if(listaObjetos[o1].aux4==0)
			{
				//aqui debe disparar
				enemyCreateShot(o1,2,-4); //comprobar que no sea del disparo
			}*/
		}
	}
		
	vmdy=listaObjetos[o1].y; getvmd();
	listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
	if(listaObjetos[o1].x==0)
	{
		listaObjetos[o1].type=0; //se va por la izquierda
	}else{
		pointerToByte=listaObjetos[o1].bytePtr;
		drawSprite16Puntero=gra_enem3a;
		drawSprite16y=listaObjetos[o1].y;
		drawSprite16();
	}
}
 
void collisionENEM3(u8 o1,u8 o2)
{
	if(listaObjetos[o2].type>1 && listaObjetos[o2].type<31)
	{
		cleanKilledObject(o2);
		
		shakeTime=2;
		
		listaObjetos[o1].aux5--;
		if(!listaObjetos[o1].aux5)
		{
			checkItemCreate(o1,0,0);
			score=score+8;
			explodeMe(o1);
		}
	}
}





//y=140
void controllerBOSS1(u8 o1)
{
	u8 r;
	
	if(!listaObjetos[o1].aux1)
	{
		listaObjetos[o1].x--;
		if(listaObjetos[o1].x==0)
		{
			listaObjetos[o1].aux1=1;
		}
	}else{
		listaObjetos[o1].x++;
		if(listaObjetos[o1].x>66)
		{
			listaObjetos[o1].aux1=0;
		}
	}
	
	
	listaObjetos[o1].aux4--;
	
	if(listaObjetos[o1].aux4>0 && listaObjetos[o1].aux3>0)
	{
		listaObjetos[o1].aux3--;
	}
	if(listaObjetos[o1].aux4<0 && listaObjetos[o1].aux3<32)
	{
		listaObjetos[o1].aux3++;
	}
	
	if(listaObjetos[o1].aux3==0)
	{
		listaObjetos[o1].aux2--;
		if(listaObjetos[o1].aux2==0)
		{
			r=cpct_getRandom_lcg_u8(0);
			listaObjetos[o1].aux2=(r/16)+1;
			if(r<8)
			{
				enemyCreateShotRocket(o1,2,-4);
			}else{
				enemyCreateShot(o1,2,-4);
			}
		}
	}

	listaObjetos[o1].y=140+listaObjetos[o1].aux3;
	
	
	vmdy=listaObjetos[o1].y; getvmd();
	listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
	cpct_drawSprite(gra_boss1, listaObjetos[o1].bytePtr, GRA_BOSS1_W, GRA_BOSS1_H-listaObjetos[o1].aux3);
}





void collisionBOSS1(u8 o1,u8 o2)
{
	//u16 porcentaje;
	if(listaObjetos[o2].type>1 && listaObjetos[o2].type<31)
	{
		listaObjetos[o1].aux5--;

		shakeTime=2;

		
		if(!listaObjetos[o1].aux5)
		{
			//nos hemos petao al boss y deberiamos de pasar de fase, pero vamos a poner un mensaje de momento y a juir
			stringAdd("     < BOSS KILLED!!!!! >      ");
			
			timeToNextLevel=200;
			
			explodeMe(o1);
			
			score=score+50;
			
		}else{
			if(listaObjetos[o1].aux5%8 == 0)
			{
				stringAdd("  < BOSS ");
				stringAddNumber(listaObjetos[o1].aux5);
				stringAdd(" SHIELD LEFT >  ");
			}
		}
		
		cleanKilledObject(o2);
		
	}
}



void controllerBOSS2(u8 o1)
{
	u8 r;
	//u8 *grafico;
	
	listaObjetos[o1].aux2--;
	if(listaObjetos[o1].aux2==0)
	{
		r=cpct_getRandom_lcg_u8(0);
		listaObjetos[o1].aux2=(r%32)+32;
		if(r<4)
		{
			enemyCreateShotRocket(o1,2,8); //1 de cada 4 seran cohetes, offset 2,8 para que centre el disparo en medio del enemigo (ya que no se en que lado va a estar lo disparo desde el centro)
		}else{
			enemyCreateShot(o1,2,8); //el resto disparos no abuses cabesa que salen 4...
		}
	}
	
	//limpiamos porque nos vamos a mover
	cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, 4, 16);
	
	
	if(listaObjetos[o1].aux1==0){
		//pa la derecha
		listaObjetos[o1].x++;
		if(listaObjetos[o1].x==74)
		{
			listaObjetos[o1].aux1=1;
		}
		//grafico=gra_boss2c;
	}else if(listaObjetos[o1].aux1==1){
		listaObjetos[o1].y=listaObjetos[o1].y+4;
		if(listaObjetos[o1].y==168)
		{
			listaObjetos[o1].aux1=2;
		}
		//grafico=gra_boss2d;
	}else if(listaObjetos[o1].aux1==2){
		listaObjetos[o1].x--;
		if(listaObjetos[o1].x==2)
		{
			listaObjetos[o1].aux1=3;
		}
		//grafico=gra_boss2a;
	}else{
		listaObjetos[o1].y=listaObjetos[o1].y-4;
		if(listaObjetos[o1].y==8)
		{
			listaObjetos[o1].aux1=0;
		}
		//grafico=gra_boss2b;
	}
	
	vmdy=listaObjetos[o1].y; getvmd();
	listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
	pointerToByte=listaObjetos[o1].bytePtr;
	if(listaObjetos[o1].aux2%2==0)
	{
		drawSprite16Puntero=gra_boss2a;
	}else{
		drawSprite16Puntero=gra_boss2b;
	}
	drawSprite16y=listaObjetos[o1].y;
	drawSprite16();
	
	//stopSceneTime=8;
}





void collisionBOSS2(u8 o1,u8 o2)
{
	u8 r;
	if(listaObjetos[o2].type>1 && listaObjetos[o2].type<31)
	{
		listaObjetos[o1].aux5--;

		shakeTime=2;

		
		if(!listaObjetos[o1].aux5)
		{
			//nos hemos petao al boss y deberiamos de pasar de fase, pero vamos a poner un mensaje de momento y a juir
			stringAdd("     < PART KILLED !!!!! >      ");

			explodeMe(o1);
			
			score=score+60;
			
			r=findEnemyIndex(40);
			if(r==255)
			{
				//si no quedan mas enemigos paso al siguiente nivel
				timeToNextLevel=200;
			}
		}
		
		cleanKilledObject(o2);
		
	}
}


//final boss y guino al chicagos 30, al final, con un par...
//esta ia va a ser muy simple, ira de izquierda a derecha y cuando le salga de los huevos saltara
//durante todo el rato estara disparando como si no hubiese un manana
//aux1 life
//aux2 jump release time
//aux3 left/right  (0 false left, 1 true right )
//aux4 shot release time
//aux5 gravedad

void controllerBOSS3(u8 o1)
{	
	u8 r;
	cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, GRA_CHICAGO30_W, GRA_CHICAGO30_H);

	//movimiento izq/der
	if(listaObjetos[o1].aux3==0)
	{
		listaObjetos[o1].x--;
		if(listaObjetos[o1].x==1)
		{
			listaObjetos[o1].aux3=1;
		}
	}else{
		listaObjetos[o1].x++;
		if(listaObjetos[o1].x>66)
		{
			listaObjetos[o1].aux3=0; 
		}
	}
	
	
	//check salto
	if(listaObjetos[o1].aux2>0)
	{
		listaObjetos[o1].aux2--;
	}else{
		if(listaObjetos[o1].y==148)
		{
			listaObjetos[o1].aux5=-14;
		}else{
			listaObjetos[o1].aux5++;
		}
		listaObjetos[o1].y=listaObjetos[o1].y+listaObjetos[o1].aux5;
		if(listaObjetos[o1].y>148)
		{
			listaObjetos[o1].aux2=(cpct_getRandom_lcg_u8(0)%128)+1;
			listaObjetos[o1].y=148;
		}
	}
	
	
	
	
	
	//check shot
	listaObjetos[o1].aux4--;
	if(listaObjetos[o1].aux4==0)
	{
		r=cpct_getRandom_lcg_u8(0);
		listaObjetos[o1].aux4=(r%32)+32;
		if(r<16)
		{
			enemyCreateShotRocket(o1,2,-4); //1 de cada 4 seran cohetes, offset 2,8 para que centre el disparo en medio del enemigo (ya que no se en que lado va a estar lo disparo desde el centro)	
		}else{
			enemyCreateShot(o1,2,-4); //el resto disparos no abuses cabesa que salen 4...
		}
	}
	

	vmdy=listaObjetos[o1].y; getvmd();
	listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
	
	cpct_drawSprite(gra_chicago30, listaObjetos[o1].bytePtr, GRA_CHICAGO30_W, GRA_CHICAGO30_H);

	//stopSceneTime=8;
}





void collisionBOSS3(u8 o1,u8 o2)
{
	
	if(listaObjetos[o2].type>1 && listaObjetos[o2].type<31)
	{
		listaObjetos[o1].aux1--;

		shakeTime=2;

		
		if(!listaObjetos[o1].aux1)
		{
			//nos hemos petao al boss y deberiamos de pasar de fase, pero vamos a poner un mensaje de momento y a juir
			stringAdd("       < ZER0 IS DIE!!!!  CONGRATULATIONS!!!! >        ");
			
			timeToNextLevel=200;
			
			explodeMe(o1);
			
			score=score+1000;
			
		}else{
			if(listaObjetos[o1].aux1%8 == 0)
			{
				stringAdd("  < BOSS LIFE: ");
				stringAddNumber(listaObjetos[o1].aux1);
				stringAdd(" >  ");
			}
		}
		
		cleanKilledObject(o2);
		
	}
}



//controlador ENEM4, meteorito (va hacia la izquierda a velocidad variable random) puede desviarse un poco
void controllerENEM4(u8 o1)
{
	//borramos la colita
	vmdy=listaObjetos[o1].y+7; getvmd();
	pointerToByte=vmdptr+listaObjetos[o1].x+3;
	*pointerToByte=0;
	vmdy=listaObjetos[o1].y+8; getvmd();
	pointerToByte=vmdptr+listaObjetos[o1].x+3;
	*pointerToByte=0;
	
	//movemos hacia la izquierda 4 pixeles (pa no complicarnos demasiao)
	listaObjetos[o1].x--;
	
	//comprobamos si el meteorito se mueve arriba o abajo algo
	listaObjetos[o1].y=listaObjetos[o1].y+listaObjetos[o1].aux4;
	if(listaObjetos[o1].y>178)
	{
		listaObjetos[o1].y=listaObjetos[o1].y-listaObjetos[o1].aux4;
	}
	
	
	
	
	//pintamos el meteorito
	if(listaObjetos[o1].x>0)
	{
		punteroDeLaMuerte=0xB400;
		colisionIndex=(listaObjetos[o1].x*64)+((listaObjetos[o1].y/4));
		if(cpct_getBit(punteroDeLaMuerte, colisionIndex))
		{
			shakeTime=2;
			explodeMe(o1);
		}else if(cpct_getBit(punteroDeLaMuerte, colisionIndex+4)){
			shakeTime=2;
			explodeMe(o1);
		}else{		
			vmdy=listaObjetos[o1].y; getvmd();
			listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
			pointerToByte=listaObjetos[o1].bytePtr;
			drawSprite16Puntero=gra_meteorb;
			drawSprite16y=listaObjetos[o1].y;
			drawSprite16();
		}
	}else{
		cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, 4, 16);
		listaObjetos[o1].type=0;
	}
}



void collisionENEM4(u8 o1,u8 o2)
{
	if(listaObjetos[o2].type>1 && listaObjetos[o2].type<31)
	{
		listaObjetos[o1].aux5--;
		if(!listaObjetos[o1].aux5)
		{
			checkItemCreate(o1,0,0);
			explodeMe(o1);
			score=score+7;
		}else{
			listaObjetos[o1].aux4=(cpct_getRandom_lcg_u8(0)%3)-1;
		}
		shakeTime=2;
		cleanKilledObject(o2);
	}
}

//controlador ENEM6, black hole, no se puede eliminar y va absorviendo todo lo que anda cerca
void controllerENEM6(u8 o1)
{
	u8 protaIndex;
	u8 dist;
	u8 pauxd;
	
	listaObjetos[o1].aux2++;
	if(listaObjetos[o1].aux2==4)
	{
		listaObjetos[o1].aux2=0;
		pointerToByte=listaObjetos[o1].bytePtr;
		drawSprite16Puntero=gra_black16a16; //limpia
		drawSprite16y=listaObjetos[o1].y;
		drawSprite16();
		//cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, 4, 16);
		listaObjetos[o1].x--;
	}
	
	
	
	listaObjetos[o1].aux3--;
	if(listaObjetos[o1].aux3==0)
	{
		protaIndex=findProtaIndex();  
		if(protaIndex<MAXOBJECTS)
		{
			//pointerToByte=videoMemLineStart[listaObjetos[protaIndex].y-2]+listaObjetos[protaIndex].x-2;
			pauxd=listaObjetos[protaIndex].y-2;
			if(pauxd<170)
			{
				vmdy=pauxd; getvmd();
				pointerToByte=vmdptr;
				pauxd=listaObjetos[protaIndex].x-2;
				if(pauxd<70)
				{
					pointerToByte=pointerToByte+pauxd;
					cpct_drawSolidBox(pointerToByte, 0, 10, 12); //limpiamos la nave porque la vamos a mover mucho
				}
			}
			
			
			if(listaObjetos[o1].y>listaObjetos[protaIndex].y)
			{
				dist=listaObjetos[o1].y-listaObjetos[protaIndex].y;
				listaObjetos[o1].aux4=2;
			}else{
				dist=listaObjetos[protaIndex].y-listaObjetos[o1].y;
				listaObjetos[o1].aux4=-2;
			}
			
			if(dist<170)
			{
				if(listaObjetos[o1].x>listaObjetos[protaIndex].x)
				{
					dist=dist+(listaObjetos[o1].x-listaObjetos[protaIndex].x);
					listaObjetos[o1].aux5=1;
				}else{
					dist=dist+(listaObjetos[protaIndex].x-listaObjetos[o1].x);
					listaObjetos[o1].aux5=-1;
				}
				
			}

			//listaObjetos[o1].aux3=2*(dist/32);  //si estamos más cerca hacemos que la nave se vaya acercando mas, hay que ajustar el maximo de atraccion sino puede ser locura
			
			if(dist<200)
			{
				redrawNave=1; //marcamos la nave como que se debe redibujar
				listaObjetos[protaIndex].y=listaObjetos[protaIndex].y+listaObjetos[o1].aux4;
				listaObjetos[protaIndex].x=listaObjetos[protaIndex].x+listaObjetos[o1].aux5;
				if(dist<50)
				{
					listaObjetos[o1].aux3=2;
				}else if(dist<100){
					listaObjetos[o1].aux3=4;
				}else if(dist<150){
					listaObjetos[o1].aux3=6;
				}else{
					listaObjetos[o1].aux3=8;
				}
			}else{
				listaObjetos[o1].aux3=16;
			}
		}
	}
	
	
	//pintamos el black hole
	if(listaObjetos[o1].x>0)
	{
		vmdy=listaObjetos[o1].y; getvmd();
		listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
		pointerToByte=listaObjetos[o1].bytePtr;
		//drawSprite16Puntero=listaSpriteHoles[listaObjetos[o1].aux2];
		drawSprite16Puntero=gra_blackholeA;
		drawSprite16y=listaObjetos[o1].y;
		drawSprite16();
	}else{
		listaObjetos[o1].type=0;
	}
}  

void collisionENEM6(u8 o1,u8 o2)
{	
	shakeTime=2;
	//cleanKilledObject(o2);
}


//controlador ENEM7, worm hole, si entras por uno sales por el otro, no se puede eliminar
void controllerENEM7(u8 o1)
{
	u8 pauxd;
	//u8 distanceFromOther=0;
	
	listaObjetos[o1].aux2++;
	if(listaObjetos[o1].aux2==4)
	{
		listaObjetos[o1].aux2=0;
		cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, 4, 16);
		//aseguramos que el borrado del otro worm hole no se vaya al karajo y pete el juego
		//es preferible dejar basura en pantalla antes que joder el juego
		pauxd=listaObjetos[o1].y+listaObjetos[o1].aux5;
		if(pauxd<172)
		{
			vmdy=pauxd; getvmd();
			pointerToByte=vmdptr;
			pauxd=listaObjetos[o1].x+listaObjetos[o1].aux4;
			if(pauxd<75)
			{
				pointerToByte=pointerToByte+pauxd;
				cpct_drawSolidBox(pointerToByte, 0, 4, 16);
			}
		}
		listaObjetos[o1].x--;
	}
	
	
	//no acabo de verlo claro esto, creo que tiene errores de calculo
	/*if(listaObjetos[o1].x>listaObjetos[o1].aux4)
	{
		distanceFromOther=distanceFromOther+(listaObjetos[o1].x-listaObjetos[o1].aux4);
	}else{
		distanceFromOther=distanceFromOther+(listaObjetos[o1].aux4-listaObjetos[o1].x);
	}

	if(distanceFromOther<20)
	{
		listaObjetos[o1].aux4=76; //si esta muy cerca, lo sacamos fuera para que vuelva a calcular otro sitio ande ponerse
	}*/
	
	
	//ajustamos para que no se vaya de camping el otro lado del wormhole
	pauxd=listaObjetos[o1].x+listaObjetos[o1].aux4;
	while(pauxd>75)
	{
		listaObjetos[o1].aux4=(cpct_getRandom_lcg_u8(0)%128)-64;
		pauxd=listaObjetos[o1].x+listaObjetos[o1].aux4;
	}
	
	pauxd=listaObjetos[o1].y+listaObjetos[o1].aux5;
	while(pauxd>172)
	{
		listaObjetos[o1].aux5=(cpct_getRandom_lcg_u8(0)%128)-64;
		pauxd=listaObjetos[o1].y+listaObjetos[o1].aux5;
	}

	//release time si se ha usado el wormhole (si es mayor que cero el wormhole no funcionara)
	if(listaObjetos[o1].aux3)
	{
		listaObjetos[o1].aux3--;
	}
	
	//pintamos el worm hole
	if(listaObjetos[o1].x>0)
	{
		pauxd=listaObjetos[o1].y+listaObjetos[o1].aux5;
		if(pauxd<172)
		{
			drawSprite16y=pauxd;
			vmdy=pauxd; getvmd();
			pointerToByte=vmdptr;
			pauxd=listaObjetos[o1].x+listaObjetos[o1].aux4;
			if(pauxd<75)
			{
				pointerToByte=pointerToByte+pauxd;
				drawSprite16Puntero=gra_wormhole1a;
				drawSprite16();
			}
		}
		vmdy=listaObjetos[o1].y; getvmd();
		listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
		pointerToByte=listaObjetos[o1].bytePtr;
		drawSprite16Puntero=gra_wormhole2a;
		drawSprite16y=listaObjetos[o1].y;
		drawSprite16();
	}else{
		listaObjetos[o1].type=0;
	}
}

void collisionENEM7(u8 o1,u8 o2)
{
	u8 pauxd;
	//si esta el relax...
	if(!listaObjetos[o1].aux3)
	{
		//miramos si podemos enviarlo al otro lado
		//primero lo borramos de aqui en la medida de lo posible
		pauxd=listaObjetos[o2].y-2;
		if(pauxd<160)
		{
			vmdy=pauxd; getvmd();
			pointerToByte=vmdptr;
			pauxd=listaObjetos[o2].x-2;
			if(pauxd<62)
			{
				pointerToByte=pointerToByte+pauxd;
				cpct_drawSolidBox(pointerToByte, 0, 10, 16);
			}
		}
		
		listaObjetos[o2].x=listaObjetos[o1].x+listaObjetos[o1].aux4;
		listaObjetos[o2].y=listaObjetos[o1].y+listaObjetos[o1].aux5;
		if(listaObjetos[o2].x>76)
		{
			listaObjetos[o2].x=0;
		}
		if(listaObjetos[o2].y>168)
		{
			listaObjetos[o2].y=0;
		}
		//vmdy=pauxd; getvmd();
		//listaObjetos[o2].bytePtr=vmdptr;
		listaObjetos[o1].aux3=8; //activamos release time
	}
}




void controllerEXPLO1(u8 o1)
{
	listaObjetos[o1].aux1--;
	if(listaObjetos[o1].aux1)
	{
		//en teoria no se va a mover la explo, asi ke nos ahorramos ese calculo
		//cpct_drawSprite(listaSpriteExplosiones[listaObjetos[o1].aux2], listaObjetos[o1].bytePtr, GRA_EXPLO1A_W, GRA_EXPLO1A_H);
		pointerToByte=listaObjetos[o1].bytePtr;
		drawSprite16Puntero=listaSpriteExplosiones[listaObjetos[o1].aux2];
		drawSprite16y=listaObjetos[o1].y;
		drawSprite16();
		
		//avanzamos la animacion
		if(listaObjetos[o1].aux1%2==0)
		{
			listaObjetos[o1].aux2++;
		}
	}else{
		if(listaObjetos[o1].aux3==1)
		{
			continuarPartida=0;   //AQUI SE RESTA UNA VIDA YA QUE ESTO ES LA EXPLOSION DE NUESTRA NAVE
			
		}
		cleanKilledObject(o1);
	}
}




void controllerSHOT1(u8 o1)
{
	//limpiamos
	listaObjetos[o1].aux2--; //este valor lo usamos para saber si tenemos que dibujar o no
	if(listaObjetos[o1].aux2%2==0)
	{
		pointerToByte=listaObjetos[o1].bytePtr; //esto es pa limpiar igual que el drawSolidBox
		drawSprite16Puntero=gra_black16a16;
		drawSprite16y=listaObjetos[o1].aux3;
		drawSprite8x4();
	}
	
	//movemos
	//aux1 --> es el desplazamiento si es mayor que 3 x=x+1; si es mayor que 250 x=x-1;
	//aux4 --> velocidad de x en cada frame (es i8 por lo tanto positivo o negativo)
	//aux5 --> velocidad de y en cada frame (es i8 por lo tanto positivo o negativo)
	
	listaObjetos[o1].aux1=listaObjetos[o1].aux1+listaObjetos[o1].aux4; //hacemos casting a s8 para poder usar negativos
	listaObjetos[o1].y=listaObjetos[o1].y + listaObjetos[o1].aux5;

	//ajustamos
	if(listaObjetos[o1].aux1>250)
	{
		listaObjetos[o1].aux1=listaObjetos[o1].aux1+4;
		listaObjetos[o1].x--;
	}else if(listaObjetos[o1].aux1>3){
		listaObjetos[o1].aux1=listaObjetos[o1].aux1-4;
		listaObjetos[o1].x++;
	}
	
	
	
	punteroDeLaMuerte=0xB400;
	//check limits
	colisionIndex=(listaObjetos[o1].x*64)+(listaObjetos[o1].y/4);
	if(cpct_getBit(punteroDeLaMuerte, colisionIndex) || listaObjetos[o1].y>186 || listaObjetos[o1].x>76)
	{
		pointerToByte=listaObjetos[o1].bytePtr; //esto es pa limpiar igual que el drawSolidBox
		drawSprite16Puntero=gra_black16a16;
		drawSprite16y=listaObjetos[o1].aux3;
		drawSprite8x4();
		listaObjetos[o1].type=0; //liberamos
	}else{
		//dibujamos
		if(listaObjetos[o1].aux2%2==0)
		{
			vmdy=listaObjetos[o1].y; getvmd();
			listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
			
			pointerToByte=listaObjetos[o1].bytePtr;
			drawSprite16Puntero=listaSpriteShot1[listaObjetos[o1].aux1];
			drawSprite16y=listaObjetos[o1].y;
			drawSprite8x4();
			listaObjetos[o1].aux3=listaObjetos[o1].y;
		}
	}
}








void cleanKilledObject(u8 o1)
{
	//if(listaObjetos[o1].type==2){
		cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, listaObjetos[o1].w, listaObjetos[o1].h); //2x1 laser normal de prota
	/*}else if(listaObjetos[o1].type==4){
		cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, 2, 4); //2x1 laser normal de prota
	}else{
		cpct_drawSolidBox(listaObjetos[o1].bytePtr, 0, 4, 16); //16*16 objeto estandar
	}*/
	
	if(listaObjetos[o1].type==3)
	{
		dividePlasma(o1);
	}
	
	listaObjetos[o1].type=0;
}





void controllerITEMS(u8 o1)
{
	//limpiamos
	cpct_drawSolidBox(listaObjetos[o1].bytePtr,0,GRA_ITEMA_W,GRA_ITEMA_H);
	
	//movemos
	//aux1 --> es el desplazamiento si es mayor que 3 x=x+1; si es mayor que 250 x=x-1;
	//aux4 --> velocidad de x en cada frame (es i8 por lo tanto positivo o negativo)
	//aux5 --> velocidad de y en cada frame (es i8 por lo tanto positivo o negativo)
	
	listaObjetos[o1].aux1=listaObjetos[o1].aux1+listaObjetos[o1].aux4; //hacemos casting a s8 para poder usar negativos
	listaObjetos[o1].y=listaObjetos[o1].y + listaObjetos[o1].aux5;

	//ajustamos
	if(listaObjetos[o1].aux1>250)
	{
		listaObjetos[o1].aux1=listaObjetos[o1].aux1+4;
		listaObjetos[o1].x--;
	}else if(listaObjetos[o1].aux1>3){
		listaObjetos[o1].aux1=listaObjetos[o1].aux1-4;
		listaObjetos[o1].x++;
	}
	
	
	vmdy=listaObjetos[o1].y; getvmd();
	listaObjetos[o1].bytePtr=vmdptr+listaObjetos[o1].x;
	
	punteroDeLaMuerte=0xB400;
	//check limits
	colisionIndex=(listaObjetos[o1].x*64)+(listaObjetos[o1].y/4);
	if(cpct_getBit(punteroDeLaMuerte, colisionIndex))
	{
		listaObjetos[o1].type=0; //liberamos
	}else if(listaObjetos[o1].y>186 || listaObjetos[o1].x>76){
		listaObjetos[o1].type=0; //liberamos
	}else{
		//dibujamos
		pointerToByte=listaObjetos[o1].bytePtr;
		drawSprite16Puntero=listaSpriteItem1[listaObjetos[o1].aux1];
		drawSprite16y=listaObjetos[o1].y;
		drawSprite8x4();
	}
}
 
void collisionITEMS(u8 o1,u8 o2)
{
	//si el item colisiona con la nave del prota
	if(listaObjetos[o2].type==1)
	{
		loadsToUpgrade--; //numero de cargas que faltan para upgradear el arma
		if(loadsToUpgrade==0)
		{
			if(weaponLevel<5)
			{
				weaponLevel++;
			}else{
				score=score+200;
			}
			loadsToUpgrade=3; //weaponLevel*3;
		}
		cleanKilledObject(o1);
	}
}
 
 
//carga una imagen de la misma forma que carga el escenario y lo scrolea xbytes veces, se pintara desplazado en el eje y lo que diga yoffset
/*void loadAndScrollImage(u8* data,u8 xbytes, u8 yoffset)
{
	//limpiamos los arrays del nivel
	for(scene2pixIndex=0;scene2pixIndex<MAX_SCENE_PIX_MUL;scene2pixIndex++)
	{
		listaSceneMAXIMA[scene2pixIndex]=0;  
	}
		
	//apuntamos el reparador a 0
	scene2pixIndexFix0=0;  
	
	//preparamos el loop de carga del nivel
	actualScenePointer=0; 
	acumDespScene=1;
	scene2pixIndex=0;
	stopSceneTime=0;
	
	moment=0;
	
	sceneYoffset=yoffset;
	sceneActual=data;
	 
	while(xbytes)
	{
		
		moverEscenarioEstrellas();
		//se llama 3 veces a la funcion para que mueva 200 bytes en cada llamada
		punteroDeLaMuerte=(&listaSceneMAXIMA[MAX_SCENE_PIX_MUL-1]);
		scrollingOMG();
		punteroDeLaMuerte=(&listaSceneMAXIMA[MAX_SCENE_PIX_MUL-801]);
		scrollingOMG();
		punteroDeLaMuerte=(&listaSceneMAXIMA[MAX_SCENE_PIX_MUL-1601]);
		scrollingOMG();
		xbytes--;
	}
}*/






void stringSet(const char *cadAux)
{
	for(index=0; cadAux[index]!=0; index++)
	{
		cadenaDrawString[index]=cadAux[index];
	}
	cadenaDrawString[index]=0;
}





void stringAdd(const char *cadAux)
{
	if(cadenaDrawString[0]==0 || cadenaDrawString[1]==0)
	{
		for(index=0; index<70; index++)
		{
			cadenaDrawString[index]=' ';
		}
		index=70;
		cadenaDrawString[index]=0;
	}else{	
		index=0;
		while(cadenaDrawString[index]!=0)
		{
			index++;
		}
	}
	//si esta ya muy petada no agregamos mas
	if(index<150)
	{
		for(index2=0; cadAux[index2]!=0; index2++)
		{
			cadenaDrawString[index++]=cadAux[index2];
		}
		cadenaDrawString[index]=0;
	}
}




void stringAddNumber(u16 n)
{
	u8 unidades;
	u8 decenas;
	u8 centenas;
	u8 miles;
	u8 diezmiles;
	
	index=0;
	while(cadenaDrawString[index]!=0)
	{
		index++;
	}

	unidades=n%10;
	n=n/10;
	decenas=n%10;
	n=n/10;
	centenas=n%10;
	n=n/10;
	miles=n%10;
	n=n/10;
	diezmiles=n%10;

	if(diezmiles>0)
	{
		cadenaDrawString[index++]='0'+diezmiles;
		cadenaDrawString[index++]='0'+miles;
		cadenaDrawString[index++]='0'+centenas;
		cadenaDrawString[index++]='0'+decenas;
		cadenaDrawString[index++]='0'+unidades;
	}else if(miles>0){
		cadenaDrawString[index++]='0'+miles;
		cadenaDrawString[index++]='0'+centenas;
		cadenaDrawString[index++]='0'+decenas;
		cadenaDrawString[index++]='0'+unidades;
	}else if(centenas>0){
		cadenaDrawString[index++]='0'+centenas;
		cadenaDrawString[index++]='0'+decenas;
		cadenaDrawString[index++]='0'+unidades;
	}else if(decenas>0){
		cadenaDrawString[index++]='0'+decenas;
		cadenaDrawString[index++]='0'+unidades;
	}else{
		cadenaDrawString[index++]='0'+unidades;
	}
	cadenaDrawString[index++]=0;  //fin cadena
	
}





u8 stringPrepare()
{
	if(cadenaWaitToShow>0)
	{
		cadenaWaitToShow--;
	}else{
		if(cadenaDrawString[0]!=0 && cadenaDrawString[1]!=0)
		{
			index=0;
			while(cadenaDrawString[index+2]!=0)
			{
				cadenaDrawString[index]=cadenaDrawString[index+2];
				index++;
			}
			cadenaDrawString[index]=0;
			
			
			index2=cadenaDrawString[70];
			cadenaDrawString[70]=0;
			punteroDeLaMuerte=0xCF85;  //y=193 x=5
			drawString2();
			cadenaDrawString[70]=index2;
			
			if(cadenaDrawString[0]=='<' || cadenaDrawString[1]=='<')
			{
				cadenaWaitToShow=10;
			}
		}
	}
	return 0;
}








// scripts-------------------------------------------
//comands/op
// 0 end script, kills this object
// 1 delay script, param time
// 2 delay scroll, param time
// 3 change palete, param color, 24-index
// 4 create object, param type, height //se puede meter alguna variable aux para sustituir sceneopt1


//listaObjetos[o1].aux1 = es el scriptPos
//listaObjetos[o1].aux2 = es el scriptDelay
//listaObjetos[o1].aux3 = actual op

void controllerScript(u8 o1)
{	
	u8 r;
	u8 t;
	u8 opt;
	if(listaObjetos[o1].aux2>0)
	{
		listaObjetos[o1].aux2--;
	}else{
		opt=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++];
		
		if(opt==0)
		{
			//DETIENE EL SCRIPT lo finaliza
			listaObjetos[o1].type=0;  
			
			
		}else if(opt==1){
			//DETIENE LA EJECUCION DEL SCRIPT durante un numero de frames
			listaObjetos[o1].aux2=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++]; 
			
			
		}else if(opt==2){
			//DETIENE EL AVANCE DEL ESCENARIO durante un numero de frames
			stopSceneTime=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++]; 
			
			
		}else if(opt==3){
			//CAMBIA UN COLOR DE LA PALETA ojo solo un color de una franja
			r=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++];
			pointerToByte=&greatPalete[r];
			*pointerToByte=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++];
			
			
		}else if(opt==4){
			//AGREGA UN OBJETO AL JUEGO
			addEnemyFromScript1=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++];
			addEnemyFromScript2=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++];
			
			
		}else if(opt==5){
			//CAMBIA UN COLOR DE LA PALETA EN TODAS LAS FRANJAS en todas menos el marcador
			r=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++];
			changePalete(r,listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++]);
		}else if(opt==6){
			//CAMBIA UN COLOR DE LA PALETA DEL MARCADOR
			r=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++];
			t=listaObjetos[o1].bytePtr[listaObjetos[o1].aux1++];
			pointerToByte=&greatPalete[r+0];
			*pointerToByte=t;
			pointerToByte=&greatPalete[r+4];
			*pointerToByte=t;
		}
	}
}


//idPal es de 0 a 3, cambia el idPal de todas las franjas menos las dos primeras
//la primera no se usa, y la segunda es la del marcador que no se cambia, queremos cambiarla manualmente
void changePalete(u8 idPal, u8 idCol)
{
	//u8 r;
	idPal=idPal+8;
	pointerToByte=&greatPalete[idPal];
	*pointerToByte=idCol;
	//for(r=0; r<5; r++)
	while(idPal<28)
	{
		pointerToByte=pointerToByte+4;
		*pointerToByte=idCol;
		idPal=idPal+4;
	}
}



